/*
 GUI engine for the Alse window
*/

on *:start:{ hmake gui 5 | hmake popups 5 }

alias gui.color {
  if ($hget(config,theme.preview)) return $hget(theme.preview,$1)
  return $hget(theme,$1)
}

alias gui.create {

  var %gui.window = $+(@GUI.,$1)
  if ($window(%gui.window)) halt 
  elseif (!$6) echo -s * $+($($gui.create,0),:) insuffisant parameter  
  elseif (. isin $1) echo -s * $+($($gui.create,0),:) "." caracter are not permitted in the name of a GUI
  else {

    if ($3-4 == -1 -1) var %gui.centre = C

    window $+(-hdokpB,%gui.centre) +dL %gui.window $3-6

    if (!%gui.centre) window %gui.window $3-4

    ; Main border of the window    
    drawrect -r %gui.window $gui.color(border) 1 0 0 $5-6
    drawline -r %gui.window $gui.color(border) 1 0 22 $5 22

    ; Shadow of the bottom part
    drawline -r %gui.window $gui.color(shadow) 1 1 $calc($6 - 2) $calc($5 - 1) $calc($6 - 2)
    drawline -r %gui.window $gui.color(shadow) 1 $calc($5 - 2) 23 $calc($5 - 2) $calc($6 - 2)

    ; Hilight of the bottom part
    drawline -r %gui.window $gui.color(hilight) 1 1 23 $calc($5 - 2) 23
    drawline -r %gui.window $gui.color(hilight) 1 1 23 1 $calc($6 - 2)

    ; Background of the bottom part
    drawrect -fr %gui.window $gui.color(bg) 1 2 24 $calc($5 - 4) $calc($6 - 26)

    ; Shadow of the titlebar part
    drawline -r %gui.window $gui.color(shadow) 1 1 21 $calc($5 - 2) 21
    drawline -r %gui.window $gui.color(shadow) 1 $calc($5 - 2) 1 $calc($5 - 2) 22

    ; Hilight of the titlebar part
    drawline -r %gui.window $gui.color(hilight) 1 1 1 $calc($5 - 2) 1
    drawline -r %gui.window $gui.color(hilight) 1 1 1 1 21

    ; Background of the titlebar part
    drawrect -fr %gui.window $gui.color(bg) 1 2 2 $calc($5 - 4) 19

    ; Minimize button (_)
    drawtext -r %gui.window $gui.color(textshadow) Webdings 11 $calc($5 - 19) 2 r
    drawtext -r %gui.window $gui.color(text) Webdings 11 $calc($5 - 20) 1 r

    ; Close button (X)
    drawtext -r %gui.window $gui.color(textshadow) Webdings 11 $calc($5 - 34) 2 0
    drawtext -r %gui.window $gui.color(text) Webdings 11 $calc($5 - 35) 1 0

    drawline -r %gui.window $gui.color(shadow) 1 $calc($5 - 45) 1 $calc($5 - 45) 22
    drawline -r %gui.window $gui.color(border) 1 $calc($5 - 44) 1 $calc($5 - 44) 22
    drawline -r %gui.window $gui.color(hilight) 1 $calc($5 - 43) 1 $calc($5 - 43) 22

    if ($width($2,Verdana,11) > $calc($5 - 75)) var %gui.text = $+($wrap($2,Verdana,11,$calc($5 - 75),0,1),...)
    else var %gui.text = $2

    ; Little square in the top left corner
    drawrect -r %gui.window $gui.color(border) 1 6 6 10 10
    drawrect -fr %gui.window $gui.color(fcontrol) 1 7 7 8 8
    drawrect -r %gui.window $gui.color(scontrol) 1 7 7 8 8
    drawline -r %gui.window $gui.color(hcontrol) 1 7 7 15 7
    drawline -r %gui.window $gui.color(hcontrol) 1 7 7 7 15

    ; Title
    drawtext -r %gui.window $gui.color(textshadow) Verdana 11 21 5 %gui.text
    drawtext -r %gui.window $gui.color(text) Verdana 11 20 4 %gui.text

    window -a %gui.window

    hadd gui lastcreated %gui.window

    .signal $+(GUI.,$1) init

    dll system\dlls\alse.dll MouseWheel $window(%gui.window).hwnd

    return $window(%gui.window).hwnd
  }

}

on *:signal:MouseWheel:{
  var %gui.name = $gui.short($active)
  var %gui.id = $hget(gui,$+(%gui.name,.focus))
  var %gui.type = $gui.getInfo(%gui.name,%gui.id).type

  var %gui.lastPosition = $hget(gui,$+(%gui.name,.,%gui.id,.sposition))

  if (%gui.type == list) || (%gui.type == lview) {
    var %gui.getPosition = $+(%gui.name,.,%gui.id,.sposition)

    ; down
    if ($2 == down) {
      tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

      if (%gui.type == lview) var %gui.hHeight = 22
      else var %gui.hHeight = 10

      var %gui.height = $height(a,Verdana,11) + 2
      var %gui.maxitem = $floor($calc(($4 - %gui.hHeight) / %gui.height))

      if ($calc($hget(gui,%gui.getPosition) + 3) <= $calc($gdid(%gui.name,%gui.id).lines - %gui.maxItem + 1)) {
        hadd gui %gui.getPosition $v1
      }
      else hadd gui %gui.getPosition $calc($gdid(%gui.name,%gui.id).lines - %gui.maxItem + 1)
    }

    ; up
    else {
      if ($calc($hget(gui,%gui.getPosition) - 3) >= 1) hadd gui %gui.getPosition $v1
      else if ($hget(gui,%gui.getPosition) > 1) hadd gui %gui.getPosition 1
    }

    if (%gui.lastPosition != $hget(gui,%gui.getPosition)) .signal -n $+(GUI.,%gui.name) SCROLL %gui.id

    if (%gui.type == list) gui.drawList %gui.name %gui.id
    if (%gui.type == lview) gui.drawListView %gui.name %gui.id
  }
}

menu @GUI.* {

  sclick {

    if (!$hget(gui,$+($gui.short($mouse.win),.stop))) {

      ; Move the GUI with the titlebar
      if ($inrect($mouse.x,$mouse.y,0,0,$calc($window($mouse.win).w - 40),22)) {
        gui.move $calc($mouse.dx - $window($mouse.win).x) $calc($mouse.dy - $window($mouse.win).y) $mouse.win
        return
      }

    }

    var %gui.compteur = 1, %gui.name = $gui.short($mouse.win)
    while ($hfind(gui,$+(%gui.name,.*.position),%gui.compteur,w)) {

      var %gui.data = $v1
      tokenize 32 $hget(gui,%gui.data)

      var %gui.id = $gettok(%gui.data,2,46)

      if ($inrect($mouse.x,$mouse.y,$1,$2,$3,$4)) && (!$gui.getInfo(%gui.name,%gui.id).hide) {

        var %gui.type = $gui.getInfo(%gui.name,%gui.id).type
        var %gui.window = $+(@GUI.,%gui.name)

        if (%gui.type == button) {
          gui.drawButton 2 %gui.window %gui.id $1-4 $gui.getInfo(%gui.name,%gui.id).text
          hadd gui $+(%gui.name,.,%gui.id,.clicked) 1
        }

        elseif (%gui.type == edit) {
          var %gui.selPos = $gui.edit.getCarPosFromX(%gui.name,%gui.id,$mouse.x)

          gui.focus %gui.window 1

          gui.changeFocus 1 %gui.name %gui.id

          ; to make the cursor flash on start
          gui.setInfo %gui.name %gui.id lastCursorFlash $calc($ticks - $hget(config,gui.cursorFlashInterval))

          gui.setInfo %gui.name %gui.id mouseDown 1
          gui.setInfo %gui.name %gui.id textSelection 0

          gui.setInfo %gui.name %gui.id selPosition %gui.selPos
          gui.setInfo %gui.name %gui.id selStart %gui.selPos

          $+(.timerGUI,%gui.name) -m 0 $hget(config,gui.cursorFlashInterval) gui.focus %gui.window
        }

        elseif (%gui.type == tbar) {     
          var %gui.x = $calc(($1 + ($3 - 13) * $gui.getInfo(%gui.name,%gui.id).sel / 100) - 2)

          if ($mouse.x > %gui.x) && ($mouse.x < $calc(%gui.x + 18)) {
            hadd gui $+(%gui.name,.,%gui.id,.pressed) 1
          }
        }

        elseif (%gui.type == check) gdid -c %gui.name %gui.id

        elseif (%gui.type == radio) gdid -c %gui.name %gui.id

        elseif (%gui.type == list) {

          var %gui.nbitem = $gdid(%gui.name,%gui.id).lines

          var %gui.height = $height(a,Verdana,11) + 2
          var %gui.maxitem = $floor($calc(($4 - 10) / %gui.height))

          ;Scrolling
          if ($calc($1 + $3 - $mouse.x) <= 15) {
            if ($calc($2 + 15) >= $mouse.y) {
              gui.scrollUp %gui.name %gui.id
              .timerscroll -m 0 100 gui.scrollUp %gui.name %gui.id
            }
            elseif ($calc($2 + $4 - 15) <= $mouse.y) {
              gui.scrollDown %gui.name %gui.id
              .timerscroll -m 0 100 gui.scrollDown %gui.name %gui.id
            }
            else {

              var %gui.y = $gui.getInfo(%gui.name,%gui.id).scrollY
              var %gui.h = $gui.getInfo(%gui.name,%gui.id).scrollH

              if ($inrect($mouse.x,$mouse.y,$calc($1 + $3 - 16),%gui.y,12,%gui.h)) {
                hadd gui $+(%gui.name,.,%gui.id,.scrollClicked) $mouse.y
              }
              else {
                if ($gui.getInfo(%gui.name,%gui.id).scrollY) {

                  var %gui.sY = $int($calc(($mouse.y - $2 - 16) / ($4 - 32) * %gui.nbItem))
                  if (%gui.sY < 1) %gui.sY = 1
                  if (%gui.sY > $calc(%gui.nbItem - %gui.maxItem + 1)) %gui.sY = $v2
                  hadd gui $+(%gui.name,.,%gui.id,.sposition) %gui.sY

                  gui.drawList %gui.name %gui.id
                }

              }

            }

            gui.drawScroll %gui.window %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)
            gui.drawScrollThumb %gui.name %gui.id

            var %gui.noSignal = 1

          }
          else {

            var %gui.sel = $int($calc(($mouse.y - $2 + %gui.height - 5) / %gui.height))
            var %gui.sposition = $gui.getInfo(%gui.name,%gui.id).sposition
            var %gui.fsel = $calc(%gui.sel + %gui.sposition - 1)

            hadd gui $+(%gui.name,.focus) %gui.id

            if (%gui.fsel <= %gui.nbitem) && ($calc(%gui.fsel - %gui.sposition) < %gui.maxitem) {
              hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.fsel
              .signal -n $+(GUI.,%gui.name) SEL %gui.id
            }
            else hdel gui $+(%gui.name,.,%gui.id,.sel)
            gui.drawList %gui.name %gui.id

          }

        }

        elseif (%gui.type == combo) {

          var %gui.cname = $+(@Combo.,%gui.name,.,%gui.id)
          if ($window(%gui.cname)) window -c $v1
          else {

            .signal -n $+(GUI.,%gui.name) COPEN %gui.id

            var %gui.height = $height(a,Verdana,11) + 2
            var %gui.xy = $calc($window(%gui.window).dx + $1) $calc($window(%gui.window).dy + $2 + $4)
            var %gui.w = $3 
            var %gui.h = $calc($hfind(gui,$+(%gui.name,.,%gui.id,.citem.*),0,w) * %gui.height + %gui.height - 3)

            window -hkdopB +dL %gui.cname %gui.xy %gui.w %gui.h

            drawrect -r %gui.cname $gui.color(border) 1 0 0 %gui.w %gui.h
            drawrect -r %gui.cname $gui.color(shadow) 1 1 1 $calc(%gui.w - 2) $calc(%gui.h - 2)

            drawline -r %gui.cname $gui.color(hilight) 1 1 1 $calc(%gui.w - 2) 1
            drawline -r %gui.cname $gui.color(hilight) 1 1 1 1 $calc(%gui.h - 2)

            drawrect -fr %gui.cname $gui.color(bg) 1 2 2 $calc(%gui.w - 4) $calc(%gui.h - 4)

            drawrect -r %gui.cname $gui.color(border) 1 3 3 $calc(%gui.w - 6) $calc(%gui.h - 6)
            drawrect -r %gui.cname $gui.color(shadow) 1 4 4 $calc(%gui.w - 8) $calc(%gui.h - 8)

            drawrect -fr %gui.cname $gui.color(hilight) 1 5 5 $calc(%gui.w - 9) $calc(%gui.h - 9)

            var %gui.compteur2 = 1, %gui.y = 7
            while ($hget(gui,$+(%gui.name,.,%gui.id,.citem.,%gui.compteur2))) {
              var %gui.text = $v1

              ; Wrap text that is longer than the list width
              if ($width(%gui.text,Verdana,11) > $calc($3 - 30)) {
                %gui.text = $+($wrap(%gui.text,Verdana,11,$calc($3 - 30),0,1),...)
              }

              drawtext -r %gui.cname $gui.color(text) Verdana 11 9 %gui.y %gui.text

              inc %gui.y %gui.height
              inc %gui.compteur2
            }

            window -a %gui.cname

          }

        }

        elseif (%gui.type == lview) {

          var %gui.nbitem = $gdid(%gui.name,%gui.id).lines

          var %gui.height = $height(a,Verdana,11) + 2
          var %gui.maxitem = $floor($calc(($4 - 22) / %gui.height))

          ;Scrolling
          if ($calc($1 + $3 - $mouse.x) <= 15) {
            if ($calc($2 + 15) >= $mouse.y) {
              gui.scrollUp %gui.name %gui.id
              .timerscroll -m 0 100 gui.scrollUp %gui.name %gui.id
            }
            elseif ($calc($2 + $4 - 15) <= $mouse.y) {
              gui.scrollDown %gui.name %gui.id
              .timerscroll -m 0 100 gui.scrollDown %gui.name %gui.id
            }
            else {
              var %gui.y = $gui.getInfo(%gui.name,%gui.id).scrollY
              var %gui.h = $gui.getInfo(%gui.name,%gui.id).scrollH

              if (%gui.y) {

                if ($inrect($mouse.x,$mouse.y,$calc($1 + $3 - 16),%gui.y,12,%gui.h)) {
                  hadd gui $+(%gui.name,.,%gui.id,.scrollClicked) $mouse.y
                }
                else {
                  var %gui.sY = $int($calc(($mouse.y - $2 - 16) / ($4 - 32) * %gui.nbItem))
                  if (%gui.sY < 1) %gui.sY = 1
                  if (%gui.sY > $calc(%gui.nbItem - %gui.maxItem + 1)) %gui.sY = $v2
                  hadd gui $+(%gui.name,.,%gui.id,.sposition) %gui.sY

                  gui.drawListView %gui.name %gui.id
                }

              }

              .signal -n $+(GUI.,%gui.name) SCROLL %gui.id

            }


            gui.drawScroll %gui.window %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)
            gui.drawScrollThumb %gui.name %gui.id

            var %gui.noSignal = 1

          }
          else {

            var %gui.sel = $int($calc(($mouse.y - $2 + %gui.height - 22) / %gui.height))
            var %gui.sposition = $gui.getInfo(%gui.name,%gui.id).sposition
            var %gui.fsel = $calc(%gui.sel + %gui.sposition - 1)

            hadd gui $+(%gui.name,.focus) %gui.id

            if (%gui.fsel <= %gui.nbitem) && ($calc(%gui.fsel - %gui.sposition) < %gui.maxitem) {
              hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.fsel
            }
            else hdel gui $+(%gui.name,.,%gui.id,.sel)

            gui.drawListView %gui.name %gui.id

          }

        }

        elseif (%gui.type == ilview) {
          var %gui.x = $floor($calc(($mouse.x - $1 - 25) / 87 + 1))
          var %gui.y = $floor($calc(($mouse.y - $2 - 10) / 65 + 1))

          gui.drawIlview %gui.name %gui.id

          gui.drawSelectedIlview $1 $2 %gui.name %gui.id %gui.x %gui.y
        }

        elseif (%gui.type == tview) {

          var %gui.nbitem = $gdid(%gui.name,%gui.id).lines

          var %gui.height = $height(a,Verdana,11) + 2
          var %gui.maxitem = $floor($calc(($4 - 10) / %gui.height))

          ;Scrolling
          if ($calc($1 + $3 - $mouse.x) <= 15) {
            if ($calc($2 + 15) >= $mouse.y) {
              gui.scrollUp %gui.name %gui.id
              .timerscroll -m 0 100 gui.scrollUp %gui.name %gui.id
            }
            elseif ($calc($2 + $4 - 15) <= $mouse.y) {
              gui.scrollDown %gui.name %gui.id
              .timerscroll -m 0 100 gui.scrollDown %gui.name %gui.id
            }
            else {

              var %gui.y = $gui.getInfo(%gui.name,%gui.id).scrollY
              var %gui.h = $gui.getInfo(%gui.name,%gui.id).scrollH

              if (%gui.y) {
                if ($inrect($mouse.x,$mouse.y,$calc($1 + $3 - 16),%gui.y,12,%gui.h)) {
                  hadd gui $+(%gui.name,.,%gui.id,.scrollClicked) $mouse.y
                }
                else {
                  var %gui.sY = $int($calc(($mouse.y - $2 - 16) / ($4 - 32) * %gui.nbItem))
                  if (%gui.sY < 1) %gui.sY = 1
                  if (%gui.sY > $calc(%gui.nbItem - %gui.maxItem + 1)) %gui.sY = $v2
                  hadd gui $+(%gui.name,.,%gui.id,.sposition) %gui.sY

                  gui.drawTreeView %gui.name %gui.id
                  gui.drawScrollThumb %gui.name %gui.id
                }
              }

            }

            gui.drawScroll %gui.window %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)
            gui.drawScrollThumb %gui.name %gui.id

            var %gui.noSignal = 1

          }
          else {

            var %gui.sel = $int($calc(($mouse.y - $2 + %gui.height) / %gui.height))
            var %gui.sposition = $gui.getInfo(%gui.name,%gui.id).sposition
            var %gui.fsel = $calc(%gui.sel + %gui.sposition - 1)

            hadd gui $+(%gui.name,.focus) %gui.id

            if (%gui.fsel <= %gui.nbitem) && ($calc(%gui.fsel - %gui.sposition) < %gui.maxitem) {
              hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.fsel
            }
            else hdel gui $+(%gui.name,.,%gui.id,.sel)
            gui.drawTreeView %gui.name %gui.id      

          }

        }

        elseif (%gui.type == mbar) {
          var %gui.x = $1, %gui.compteur2 = 1, %gui.items = $gui.getInfo(%gui.name,%gui.id).items

          while (%gui.x < $mouse.x) && ($gettok(%gui.items,%gui.compteur2,8)) {
            var %gui.lwidth = $calc($width($v1,Verdana,11) + 10)
            inc %gui.x %gui.lwidth
            inc %gui.compteur2 2
          }

          while ($window(@Popups*,1)) popups.close $v1

          if (%gui.compteur2 > 1) {
            var %gui.x = $calc($window($mouse.win).dx + %gui.x - %gui.lwidth - 5)
            var %gui.y = $calc($window($mouse.win).dy + $2 + 16)

            $gettok(%gui.items,$calc(%gui.compteur2 - 1),8) %gui.x %gui.y
          }
        }

        elseif (%gui.type == tbButton) {
          gui.drawTbButton 2 %gui.window %gui.id $1-4 $gui.getInfo(%gui.name,%gui.id).icon
          hadd gui $+(%gui.name,.,%gui.id,.clicked) 1
          .signal -n $+(GUI.,%gui.name) DOWN %gui.id
        }

        if (%gui.type != button) && (%gui.type != tbButton) && (%gui.type != combo) {
          if (!%gui.noSignal) .signal -n $+(GUI.,%gui.name) SCLICK %gui.id
        }

      }

      inc %gui.compteur
    }

  }

  rclick {
    var %gui.compteur = 1, %gui.name = $gui.short($mouse.win)
    while ($hfind(gui,$+(%gui.name,*.position),%gui.compteur,w)) {

      var %gui.data = $v1
      tokenize 32 $hget(gui,%gui.data)

      if ($inrect($mouse.x,$mouse.y,$1,$2,$3,$4)) {

        var %gui.id = $gettok(%gui.data,2,46)
        var %gui.type = $gui.getInfo(%gui.name,%gui.id).type
        var %gui.window = $+(@GUI.,%gui.name)

        if (%gui.type == lview) && ($calc($1 + $3 - $mouse.x) > 15) .signal -n $+(GUI.,%gui.name) RCLICK %gui.id

        elseif (%gui.type == edit) {

          var %gui.textSelection = $gui.getInfo(%gui.name,%gui.id).textSelection

          ; If no text is in selection
          if (!%gui.textSelection) {

            var %gui.selPos = $gui.edit.getCarPosFromX(%gui.name,%gui.id,$mouse.x)
            gui.focus $mouse.win 1
            gui.changeFocus 1 %gui.name %gui.id
            $+(.timerGUI,%gui.name) -m 0 $hget(config,gui.cursorFlashInterval) gui.focus $mouse.win
          }

          var %gui.text = $gdid(%gui.name,%gui.id).text
          var %gui.selText = $gdid(%gui.name,%gui.id).selText
          var %gui.textSelection = $gui.getInfo(%gui.name,%gui.id).textSelection

          popups.add edit Undo:gui.popUndo %gui.name %gui.id $mouse.win
          popups.add edit -
          popups.add edit $iif(!%gui.textSelection,-b) Cut:gui.edit.cutSelectedText %gui.name %gui.id %gui.textSelection
          popups.add edit $iif(!%gui.textSelection,-b) Copy:gui.edit.copy %gui.name %gui.id
          popups.add edit $iif(!%gui.textSelection,-b) Delete:gui.deleteSelectedText %gui.name %gui.id
          popups.add edit $iif($cb(0) == 0,-b) Paste:gui.edit.pasteClipboard %gui.name %gui.id
          popups.add edit -
          popups.add edit $iif($len(%gui.text) == 0,-b) Select all:gui.popSelectAll %gui.name %gui.id $mouse.win
          popups.draw edit

        }

      }

      inc %gui.compteur

    }

  }

  dclick {

    var %gui.compteur = 1, %gui.name = $gui.short($mouse.win)
    while ($hfind(gui,$+(%gui.name,*.position),%gui.compteur,w)) {

      var %gui.data = $v1
      tokenize 32 $hget(gui,%gui.data)

      var %gui.id = $gettok(%gui.data,2,46)
      var %gui.type = $gui.getInfo(%gui.name,%gui.id).type

      if (%gui.type == ilview) {
        var %gui.x = $floor($calc(($mouse.x - $1 - 25) / 100 + 1))
        var %gui.y = $floor($calc(($mouse.y - $2 - 10) / 65 + 1))

        var %gui.rows = $hget(gui,$+(%gui.name,.,%gui.id,.rows))
        var %gui.sclick = $calc(%gui.x + (%gui.y - 1) * %gui.rows)

        if (%gui.x <= %gui.rows) && (%gui.y <= $hget(gui,$+(%gui.name,.,%gui.id,.lines))) && (%gui.x) && (%gui.y) {
          if ($hget(gui,$+(%gui.name,.,%gui.id,.ilvitem.,%gui.sclick))) {
            .signal -n $+(GUI.,%gui.name) SCLICK %gui.id %gui.sclick
          }
        }
      }

      if (%gui.type == list) || (%gui.type == lview) || (%gui.type == tview) var %gui.w = $3 - 20
      else var %gui.w = $3

      if ($inrect($mouse.x,$mouse.y,$1,$2,%gui.w,$4)) {

        .signal -n $+(GUI.,%gui.name) DCLICK %gui.id

      }

      inc %gui.compteur

    }
  }

  uclick {

    var %gui.name = $gui.short($mouse.win)

    gui.upButton $mouse.win
    gui.upScroll $mouse.win

    var %gui.compteur = 1
    while ($hfind(gui,$+(%gui.name,.*.pressed),%gui.compteur,w)) {
      var %gui.item = $v1, %gui.id = $gettok(%gui.item,2,46) | hdel gui %gui.item  

      if ($hget(gui,$+($gettok(%gui.item,1-2,46),.type)) == tbar) {
        tokenize 32 $gui.getInfo(%gui.name,%gui.id).position
        var %gui.percent = $calc(($mouse.x - $1 - 7) / $3 * 100)

        .signal -n $+(GUI.,%gui.name) UCLICK %gui.id %gui.percent
      } 

      inc %gui.compteur
    }

    hdel -w gui $+(%gui.name,.*.scrollClicked)
    hdel -w gui $+(%gui.name,.*.mouseDown)

    if (!$hget(gui,$+(%gui.name,.stop))) {

      if ($inrect($mouse.x,$mouse.y,6,6,10,10)) {
        popups.add alse Open in editor:gui.openInEditor $gui.short($mouse.win)
        popups.add alse -
        popups.add alse Minimize:window -n $mouse.win
        popups.add alse Close:gui.close $gui.short($mouse.win)

        popups.draw alse

      }

      if ($inrect($mouse.x,$mouse.y,$calc($window($mouse.win).w - 35),5,10,10)) window -n $mouse.win
      elseif ($inrect($mouse.x,$mouse.y,$calc($window($mouse.win).w - 18),5,10,10)) gui.close %gui.name

    }

  }

  leave {

    var %gui.name = $gui.short($mouse.win)

    gui.upButton $mouse.win
    gui.upScroll $mouse.win
    hdel -w gui $+(%gui.name,.*.pressed)

    var %gui.compteur = 1
    while ($hfind(gui,mbar,%gui.compteur).data) {
      if ($+(%gui.name,.*.type) iswm $v1) { var %gui.id = $gettok($v2,2,46) | break }
      inc %gui.compteur
    }

    if (%gui.id) {
      tokenize 32 $gui.getInfo(%gui.name,%gui.id).position
      var %gui.x = $1, %gui.y = $2, %gui.width = $gui.getInfo(%gui.name,%gui.id).width
      drawrect -frn $mouse.win $gui.color(bg) 1 $calc(%gui.x - 5) $calc(%gui.y - 2) %gui.width 20  
      gui.drawMbar $mouse.win %gui.id %gui.x %gui.y $gui.getInfo(%gui.name,%gui.id).items
      drawdot $mouse.win
    }

  }

  mouse {

    var %gui.name = $gui.short($mouse.win)

    if ($mouse.key == 1) {

      var %gui.id = $gettok($hfind(gui,$+(%gui.name,.*.pressed),1,w),2,46)

      if (%gui.id) {
        tokenize 32 $gui.getInfo(%gui.name,%gui.id).position
        var %gui.percent = $calc(($mouse.x - $1 - 7) / ($3 - 14) * 100)

        if (%gui.percent >= 0) && (%gui.percent <= 100) {
          gui.drawTbar $mouse.win $1-4 %gui.percent
          hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.percent
          .signal -n $+(GUI.,%gui.name) MOUSE %gui.id %gui.percent
        }
      }


      var %gui.id = $gettok($hfind(gui,$+(%gui.name,.*.mouseDown),1,w),2,46)

      if (%gui.id) {
        tokenize 32 $gui.getInfo(%gui.name,%gui.id).position
        var %gui.carPos = $gui.edit.getCarPosFromX(%gui.name,%gui.id,$mouse.x)
        var %gui.selX = $gui.edit.getXFromCarPos(%gui.name,%gui.id,%gui.carPos)
        var %gui.selXRel = $gui.edit.getXFromCarPos(%gui.name,%gui.id,%gui.carPos).relative

        ; Check if we need to scroll on the left
        if (%gui.selXrel <= 2) {
          var %cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition
          dec %cursorPosition 4
          if (%cursorPosition < 1) %cursorPosition = 1
          gui.setInfo %gui.name %gui.id cursorPosition %cursorPosition
        }

        ; Check if we need to scroll on the right
        if (%gui.selXRel >= $calc($3 - 2)) {
          var %cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition
          gui.setInfo %gui.name %gui.id cursorPosition $calc(%cursorPosition + 4)
        }

        gui.setInfo %gui.name %gui.id selPosition %gui.carPos
        gui.setInfo %Gui.name %gui.id newCarretPosition %gui.carPos
        gui.setInfo %gui.name %gui.id textSelection 1

        gui.focus $mouse.win
      }

      var %gui.x = $hfind(gui,$+(%gui.name,.*.scrollClicked),1,w)
      var %gui.id = $gettok(%gui.x,2,46)

      if (%gui.id) {

        var %gui.height = $calc($height(a,Verdana,11) + 2)
        var %gui.nbItems = $gdid(%gui.name,%gui.id).lines

        var %gui.type = $gui.getInfo(%gui.name,%gui.id).type

        tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

        if (%gui.type == lview) var %gui.rHeight = 22 | else var %gui.rHeight = 10
        var %gui.maxItem = $floor($calc(($4 - %gui.rHeight) / %gui.height))

        var %gui.y = $int($calc(($mouse.y - $2 - 16) / ($4 - 32) * %gui.nbItems))

        if (%gui.y < 1) %gui.y = 1
        if (%gui.y > $calc(%gui.nbItems - %gui.maxItem + 1)) %gui.y = $v2

        hadd gui $+(%gui.name,.,%gui.id,.sposition) %gui.y
        hadd gui $+(%gui.name,.,%gui.id,.scrollClicked) $mouse.y

        if (%gui.type == list) gui.drawList %gui.name %gui.id
        elseif (%gui.type == lview) gui.drawListView %gui.name %gui.id
        elseif (%gui.type == tview) gui.drawTreeView %gui.name %gui.id

        .signal -n $+(GUI.,%gui.name) SCROLL %gui.id
      }

    }

    ;gui.mBarMouseOver $mouse.x $mouse.y $mouse.win

  }

}

alias gui.openInEditor {
  gui.close $1

  var %gui.info = $gui.findLineForWindow($1)
  tokenize 44 $gettok($gettok(%gui.info,2-,40),1,41)

  hadd -m gedit name $1

  if (!$window(@GUI.gEdit)) geditor
  if ($window(@GUI.geditProps)) gui.close geditProps
  gedit.openEditWindow $gettok(%gui.info,1,32) $3-6 $gettok(%gui.info,3,32) $2

}

; Search the line where the specified window is created
; /gui.findLineForWindow <gui name>
alias gui.findLineForWindow {
  .fopen gedit system\kernel.mrc
  var %gui.nbLine = 1

  while (!$feof) && (!ferr) {
    var %gui.read = $fread(gedit)
    var %gui.var = $gettok(%gui.read,1,32)
    var %gui.var2 = $gettok(%gui.read,2,32)

    var %gui.text = $+($eval(.window = $gui.create,0),$chr(40),$1,$chr(44))

    if ((%gui.var == var) || (%gui.var2 == var)) && (%gui.text isin %gui.read) {
      .fclose gedit
      return %gui.nbLine %gui.read
    }

    inc %gui.nbLine
  }

  .fclose gedit
  return -1
}

alias gui.showToolTips {

  var %gui.compteur = 1, %gui.name = $1, %gui.nover = 0
  while ($hfind(gui,$+(%gui.name,*.position),%gui.compteur,w)) {
    var %gui.data = $v1
    tokenize 32 $hget(gui,%gui.data)

    var %gui.id = $gettok(%gui.data,2,46)

    if ($inrect($mouse.x,$mouse.y,$1,$2,$3,$4)) && (!$gui.getInfo(%gui.name,%gui.id).hide) {

      var %gui.nover = %gui.id 

      if (%gui.nover != $hget(gui,$+(%gui.name,.cover))) && ($gui.getInfo(%gui.name,%gui.id).tooltips) {

        var %gui.text = $v1
        var %gui.width = $width(%gui.text,Verdana,11) + 10

        window -kpBhwzdo +dL @tooltips $calc($mouse.x + 2) $calc($mouse.y + 18) %gui.width 20
        showmirc -s
        drawrect -frn @tooltips $gui.color(fcontrol) 1 0 0 %gui.width 20
        drawrect -rn @tooltips $gui.color(border) 1 0 0 %gui.width 20
        drawtext -rn @tooltips $gui.color(text) Verdana 11 5 3 %gui.text
        drawdot @tooltips

        hadd gui $+(%gui.name,.cover) %gui.nover

        break

      }

    }
    inc %gui.compteur
  }

  if (%gui.nover != $hget(gui,$+(%gui.name,.cover))) {
    hadd gui $+(%gui.name,.cover) %gui.nover
    window -c @tooltips
  }

}

alias gui.edit.cutSelectedText {

  var %gui.name = $1, %gui.id = $2,  %gui.oldTextSelection = $3-

  if (%gui.oldTextSelection) {
    gui.setInfo %gui.name %gui.id oldText $gui.getInfo(%gui.name,%gui.id).text
    clipboard $gui.getInfo(%gui.name,%gui.id).selText
    gui.deleteSelectedText %gui.name %gui.id
  }

  gui.setInfo %gui.name %gui.id textSelection 0

  gui.focus $active 1
}

alias gui.edit.copy {
  clipboard $gui.getInfo($1,$2).selText
}

alias gui.edit.pasteClipboard {
  var %gui.name = $1, %gui.id = $2
  var %gui.editWidth = $gettok($gui.getInfo(%gui.name,%gui.id).position,3,32)

  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
  if ($calc($len(%gui.text) + $len($cb(1))) > 900) return
  %gui.text = $+(%gui.text,$cb(1))

  var %gui.textLen = $len(%gui.text)
  var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition
  var %gui.maxChars = $len($wrap($mid(%gui.text,%gui.cursorPosition),Tahoma,11,$calc(%gui.editWidth - 5),0,1))

  var %gui.newCursorPosition = $calc(%gui.textlen - %gui.maxChars)
  if (%gui.newCursorPosition < 1) %gui.newCursorPosition = 1
  if (%gui.newCursorPosition > %gui.textLen) %gui.newCursorPosition = %gui.textLen

  ; Copy the text for the undo feature
  gui.setInfo %gui.name %gui.id oldText $gui.getInfo(%gui.name,%gui.id).text

  ; Delete the text that was selected (if any)
  if ($gui.getInfo(%gui.name,%gui.id).oldTextSelection) {
    gui.deleteSelectedText %gui.name %gui.id
  }

  var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition
  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text

  ; Put the cursor at the right place
  hinc gui $+(%gui.name,.,%gui.id,.selPosition) $calc($len($cb(1)) - 1)

  gui.setInfo %gui.name %gui.id cursorPosition %gui.newCursorPosition

  var %gui.newText
  if (%gui.selPosition > 1) {
    %gui.newText = $mid(%gui.text,1,$calc(%gui.selPosition - 1))
  }

  %gui.newText = $+(%gui.newText,$cb(1),$mid(%gui.text,%gui.selPosition))

  gui.setInfo %gui.name %gui.id text %gui.newText

  gui.edit.drawText 1 0 $active
}

alias gui.popSelectAll { gui.edit.selectAll $1 $2 | gui.focus $3 1 }
alias gui.popUndo { gui.edit.undo $1 $2 | gui.focus $3 1 }

alias gui.edit.undo {
  var %gui.name = $1, %gui.id = $2
  var %gui.oldText = $gui.getinfo(%gui.name,%gui.id).oldText
  gui.setInfo %gui.name %gui.id oldText $gui.getInfo(%gui.name,%gui.id).text
  gui.setinfo %gui.name %gui.id text %gui.oldText
}

alias gui.edit.selectAll {
  var %gui.name = $1, %gui.id = $2
  gui.setInfo %gui.name %gui.id textSelection 1
  gui.setInfo %gui.name %gui.id selStart 1
  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
  var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition
  var %gui.newX = $gui.edit.getXFromCarPos(%gui.name,%gui.id,$len(%gui.text))
  gui.setInfo %gui.name %gui.id selPosition $calc($len(%gui.text) + 1)
  gui.setInfo %Gui.name %gui.id NewCarretPosition $calc($len(%gui.text) + 1)
}

menu @Combo* {
  mouse {
    var %gui.height = $height(a,Verdana,11) + 2
    var %gui.sel = $int($calc(($mouse.y - 7) / %gui.height + 1))
    var %gui.name = $gettok($mouse.win,2,46), %gui.id = $gettok($mouse.win,3,46)

    tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

    if (%gui.sel) && ($hfind(gui,$+(%gui.name,.,%gui.id,.citem.*),%gui.sel,w)) {
      var %gui.y = $calc((%gui.sel * %gui.height) - %gui.height + 7) 
      var %gui.text = $hget(gui,$+(%gui.name,.,%gui.id,.citem.,%gui.sel))

      drawrect -rn $mouse.win $gui.color(scontrol) 1 6 %gui.y $calc($3 - 12) $calc(%gui.height - 1)
      drawrect -frn $mouse.win $gui.color(fcontrol) 1 7 $calc(%gui.y + 1) $calc($3 - 14) $calc(%gui.height - 3)

      ;Wrap text that is longer than the list width
      if ($width(%gui.text,Verdana,11) > $calc($3 - 30)) {
        %gui.text = $+($wrap(%gui.text,Verdana,11,$calc($3 - 30),0,1),...)
      }

      drawtext -rn $mouse.win $gui.color(textshadow) Verdana 11 10 $calc(%gui.y + 1) %gui.text  
      drawtext -rn $mouse.win $gui.color(text) Verdana 11 9 %gui.y %gui.text  

      var %gui.fsel = %gui.sel
    }

    var %gui.osel = $gui.getInfo(%gui.name,%gui.id).over

    if (%gui.osel != %gui.fsel) && (%gui.osel) {
      var %gui.y = $calc((%gui.osel * %gui.height) - %gui.height + 7) 
      var %gui.text = $hget(gui,$+(%gui.name,.,%gui.id,.citem.,%gui.osel))

      drawrect -frn $mouse.win $gui.color(hilight) 1 6 %gui.y $calc($3 - 12) $calc(%gui.height - 1)

      ;Wrap text that are longer than the list width
      if ($width(%gui.text,Verdana,11) > $calc($3 - 30)) {
        %gui.text = $+($wrap(%gui.text,Verdana,11,$calc($3 - 30),0,1),...)
      }

      drawtext -rn $mouse.win $gui.color(text) Verdana 11 9 %gui.y %gui.text
    }

    if (%gui.fsel) hadd gui $+(%gui.name,.,%gui.id,.over) %gui.fsel
    else hdel gui $+(%gui.name,.,%gui.id,.over)

    drawdot $mouse.win

  }
  sclick {
    var %gui.height = $height(a,Verdana,11) + 2
    var %gui.sel = $int($calc(($mouse.y - 7) / %gui.height + 1))
    var %gui.name = $gettok($mouse.win,2,46), %gui.id = $gettok($mouse.win,3,46)

    tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

    if (%gui.sel) && ($hfind(gui,$+(%gui.name,.,%gui.id,.citem.*),%gui.sel,w)) {
      gui.drawComboSelect %gui.name %gui.id %gui.sel
      .signal -n $+(GUI.,%gui.name) SCLICK %gui.id %gui.sel
    }

    drawdot $+(@GUI.,%gui.name)

    window -c $mouse.win
  }
}

alias gui.drawComboSelect {
  hadd gui $+($1,.,$2,.sel) $3

  var %gui.text = $hget(gui,$+($1,.,$2,.citem.,$3))
  var %gui.window = $+(@GUI.,$1)

  tokenize 32 $gui.getInfo($1,$2).position

  ;Wrap text that are longer than the combo width
  if ($width(%gui.text,Verdana,11) > $calc($3 - 30)) {
    %gui.text = $+($wrap(%gui.text,Verdana,11,$calc($3 - 30),0,1),...)
  }

  drawrect -frn %gui.window $gui.color(fcontrol) 1 $calc($1 + 2) $calc($2 + 2) $calc($3 - 14) $calc($4 - 4)

  if (%gui.text) {
    drawtext -rn %gui.window $gui.color(textshadow) Verdana 11 $calc($1 + 6) $calc($2 + ($4 / 2) - 6) %gui.text
    drawtext -rn %gui.window $gui.color(text) Verdana 11 $calc($1 + 5) $calc($2 + ($4 / 2) - 7) %gui.text
  }

  if (!$hget(gui,$+($gui.short(%gui.window),.stopDraw))) drawdot %gui.window
}

on *:active:*:{ 
  gui.activeEvent $active $lactive
}

alias gui.activeEvent {

  if ($gettok($1,1,46) != @Combo) { while ($window(@Combo.*,1)) window -c $v1 }
  if ($gettok($2,1,46) == @Popups) {
    var %pop.submenu = $findtok($hget(popups,$+($gettok($1,2-,46),.submenus)),$gettok($2,2-,46),1,32)
    if (%pop.submenu) popups.close $2 1
  }
  if ($gettok($1,1,46) != @Popups) { while ($window(@Popups.*,1)) popups.close $v1 }

}

on *:appactive:{
  if (!$appactive) {
    while ($window(@Combo.*,1)) window -c $v1 
    while ($window(@Popups.*,1)) popups.close $v1
  }
}

alias gui.mBarMouseOver {

  var %gui.mx = $1, %gui.my = $2, %gui.window = $3, %gui.name = $gui.short($3)

  ; Menubar (mouse over)
  var %gui.compteur = 1
  while ($hfind(gui,mbar,%gui.compteur).data) {
    if (*.type iswm $v1) && ($+(%gui.name,.*) iswm $v2) { var %gui.id = $gettok($v2,2,46) | break }
    inc %gui.compteur
  }

  tokenize 32 $gui.getInfo(%gui.name,%gui.id).position
  var %gui.x = $1, %gui.y = $2, %gui.width = $gui.getInfo(%gui.name,%gui.id).width

  if (%gui.id) && ($inrect(%gui.mx,%gui.my,%gui.x,%gui.y,%gui.width,20)) {

    var %gui.compteur = 1
    var %gui.items = $gui.getInfo(%gui.name,%gui.id).items

    drawrect -frn %gui.window $gui.color(bg) 1 $calc(%gui.x - 5) $calc(%gui.y - 2) %gui.width 20
    gui.drawMbar %gui.window %gui.id %gui.x %gui.y %gui.items

    while (%gui.x < %gui.mx) && ($gettok(%gui.items,%gui.compteur,8)) {
      var %gui.lwidth = $calc($width($v1,Verdana,11) + 10)
      inc %gui.x %gui.lwidth
      inc %gui.compteur 2
    }

    var %gui.ox = $calc(%gui.x - %gui.lwidth - 5)
    var %gui.text = $gettok(%gui.items,$calc(%gui.compteur - 2),8)

    if (%gui.lwidth) {
      drawrect -rn %gui.window $gui.color(scontrol) 1 %gui.ox $calc(%gui.y - 2) %gui.lwidth 18
      drawrect -frn %gui.window $gui.color(fcontrol) 1 $calc(%gui.ox + 1) $calc(%gui.y - 1) $calc(%gui.lwidth - 2) 16
      drawtext -rn %gui.window $gui.color(textshadow) Verdana 11 $calc(%gui.ox + 6) $calc(%gui.y + 1) %gui.text
      drawtext -rn %gui.window $gui.color(text) Verdana 11 $calc(%gui.ox + 5) %gui.y %gui.text
      drawdot %gui.window
    }

    ; When moving over the menubar when a popups is already open
    if ($hget(gui,$+(%gui.name,.,%gui.id,.over)) != %gui.ox) {

      if ($window(@Popups.*,1)) {

        var %gui.x = $1, %gui.compteur2 = 1, %gui.items = $gui.getInfo(%gui.name,%gui.id).items

        while (%gui.compteur2 < %gui.compteur) && ($gettok(%gui.items,%gui.compteur2,8)) {
          var %gui.lwidth = $calc($width($v1,Verdana,11) + 10)
          inc %gui.x %gui.lwidth
          inc %gui.compteur2 2
        }

        while ($window(@Popups*,1)) popups.close $v1

        if (%gui.compteur2 > 1) {

          var %gui.pos = $calc($window($mouse.win).dx + %gui.x - %gui.lwidth - 5) $calc($window($mouse.win).dy + $2 + 16)       
          $gettok(%gui.items,$calc(%gui.compteur2 - 1),8) %gui.pos

        }

      }

      hadd gui $+(%gui.name,.,%gui.id,.over) %gui.ox
    }

  }

}

alias -l gui.upButton {

  var %gui.compteur = 1
  while ($hfind(gui,*.clicked,%gui.compteur,w)) {
    var %gui.data = $v1
    var %gui.name = $gettok(%gui.data,1,46)
    var %gui.id = $gettok(%gui.data,2,46)
    var %gui.type = $gui.getInfo(%gui.name,%gui.id).type

    tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

    if (%gui.type == button) {
      var %gui.positiontext = $1-4 $gui.getInfo(%gui.name,%gui.id).text
      gui.drawButton 1 $+(@GUI.,%gui.name) %gui.id %gui.positiontext
    }
    elseif (%gui.type == tbbutton) {
      if ($gui.getInfo(%gui.name,%gui.id).check) return
      var %gui.positionicon = $1-4 $gui.getInfo(%gui.name,%gui.id).icon
      gui.drawTbButton 1 $+(@GUI.,%gui.name) %gui.id %gui.positionicon
    }

    if ($inrect($mouse.x,$mouse.y,$1,$2,$3,$4)) {
      if ($mouse.key == 4) .signal -n $+(GUI.,%gui.name) SSCLICK %gui.id
      else .signal -n $+(GUI.,%gui.name) SCLICK %gui.id
    }

    hdel gui $+(%gui.name,.,%gui.id,.clicked)

    inc %gui.compteur
  }

}

alias -l gui.upScroll {

  .timerscroll off

  var %gui.compteur = 1
  while ($hfind(gui,$+($gui.short($1),.*.?Scroll),%gui.compteur,w)) {
    hdel gui $v1
    tokenize 46 $v1

    var %gui.name = $1
    var %gui.id = $2

    tokenize 32 $gui.getInfo($1,$2).position
    gui.drawScroll $+(@GUI.,%gui.name) %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)    
    gui.drawScrollThumb %gui.name %gui.id

    inc %gui.compteur
  }

  if (%gui.name) drawdot $+(@GUI.,%gui.name)

}

alias gui.scrollUp {
  if ($gui.getInfo($1,$2).sposition == 1) return
  hadd gui $+($1,.,$2,.uScroll) 1
  hdec gui $+($1,.,$2,.sposition)

  var %gui.position = $gui.getInfo($1,$2).position
  var %gui.type = $gui.getInfo($1,$2).type

  if (%gui.type == list) gui.drawList $1 $2
  elseif (%gui.type == lview) gui.drawListView $1 $2
  elseif (%gui.type == tview) gui.drawTreeview $1 $2

  var %gui.window = $+(@GUI.,$1), %gui.name = $1, %gui.id = $2

  tokenize 32 $gui.getInfo($1,$2).position 
  var %gui.x = $calc($1 + $3 - 16) 
  var %gui.y = $calc($2 + 4) 

  drawrect -frn %gui.window $gui.color(bg) 1 %gui.x %gui.y 12 11
  drawrect -rn %gui.window $gui.color(hilight) 1 %gui.x %gui.y 12 11
  drawline -rn %gui.window $gui.color(shadow) 1 %gui.x %gui.y $calc(%gui.x + 12) %gui.y
  drawline -rn %gui.window $gui.color(shadow) 1 %gui.x %gui.y %gui.x $calc(%gui.y + 11)

  gui.drawScrollThumb %gui.name %gui.id
  .signal -n $+(GUI.,%gui.name) SCROLL %gui.id
}

alias gui.scrollDown {
  var %gui.nbitem = $gdid($1,$2).lines

  var %gui.position = $gui.getInfo($1,$2).position
  var %gui.h = $gettok(%gui.position,4,32)

  var %gui.type = $gui.getInfo($1,$2).type

  if (%gui.type == lview) var %gui.hHeight = 22 | else var %gui.hHeight = 10

  var %gui.height = $height(a,Verdana,11) + 2
  var %gui.maxitem = $floor($calc((%gui.h - %gui.hHeight) / %gui.height)) 

  if ($calc(%gui.nbitem - %gui.maxitem + 1) == $gui.getInfo($1,$2).sposition) return
  if ($calc(%gui.nbitem - %gui.maxitem) < 0) return
  hadd gui $+($1,.,$2,.dScroll) 1
  hinc gui $+($1,.,$2,.sposition)

  if (%gui.type == list) gui.drawList $1 $2
  elseif (%gui.type == lview) gui.drawListView $1 $2
  elseif (%gui.type == tview) gui.drawTreeview $1 $2

  var %gui.window = $+(@GUI.,$1), %gui.name = $1, %gui.id = $2

  tokenize 32 $gui.getInfo($1,$2).position 
  var %gui.x = $calc($1 + $3 - 17) 
  var %gui.y = $calc($2 + 3)
  var %gui.h = $calc($4 - 6 - 12)

  var %gui.dline = 1 $calc(%gui.x + 1) $calc(%gui.y + %gui.h)

  drawrect -frn %gui.window $gui.color(bg) 1 $calc(%gui.x + 1) $calc(%gui.y + %gui.h) 12 11
  drawrect -rn %gui.window $gui.color(hilight) %gui.dline 12 11
  drawline -rn %gui.window $gui.color(shadow) %gui.dline $calc(%gui.x + 13) $calc(%gui.y + %gui.h)
  drawline -rn %gui.window $gui.color(shadow) %gui.dline $calc(%gui.x + 1) $calc(%gui.y + %gui.h + 11)

  gui.drawScrollThumb %gui.name %gui.id
  .signal -n $+(GUI.,%gui.name) SCROLL %gui.id
}

alias gui.button {

  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.button: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) button
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.text) $6-

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) gui.drawButton 1 %gui.window $1-
  }

}

alias gui.drawButton {

  if ($hget(gui,$+($gui.short($2),.,$3,.pushed))) {
    var %gui.color1 = $gui.color(hcontrol), %gui.color2 = $gui.color(scontrol)
  }
  else {
    if ($1 == 1) var %gui.color1 = $gui.color(scontrol), %gui.color2 = $gui.color(hcontrol)
    else var %gui.color1 = $gui.color(hcontrol), %gui.color2 = $gui.color(scontrol)
  }

  drawrect -rnf $2 $gui.color(fcontrol) 1 $calc($4 + 2) $calc($5 + 2) $calc($6 - 5) $calc($7 - 5)
  drawline -rn $2 $gui.color(border) 1 $4 $5 $calc($4 + $6) $5
  drawline -rn $2 $gui.color(border) 1 $4 $5 $4 $calc($5 + $7)
  drawline -rn $2 $gui.color(border) 1 $4 $calc($5 + $7) $calc($4 + $6 - 5) $calc($5 + $7)
  drawline -rn $2 $gui.color(border) 1 $calc($4 + $6) $5 $calc($4 + $6) $calc($5 + $7 - 5)
  drawline -rn $2 $gui.color(border) 1 $calc($4 + $6 - 6) $calc($5 + $7) $calc($4 + $6) $calc($5 + $7 - 6)

  drawline -rn $2 $gui.color(fcontrol) 1 $calc($4 + $6 - 2) $calc($5 + 1) $calc($4 + $6 - 2) $calc($5 + $7 - 5)
  drawline -rn $2 $gui.color(fcontrol) 1 $calc($4 + $6 - 3) $calc($5 + 1) $calc($4 + $6 - 3) $calc($5 + $7 - 4)
  drawline -rn $2 $gui.color(fcontrol) 1 $calc($4 + 1) $calc($5 + $7 - 3) $calc($4 + $6 - 4) $calc($5 + $7 - 3)
  drawline -rn $2 $gui.color(fcontrol) 1 $calc($4 + 1) $calc($5 + $7 - 2) $calc($4 + $6 - 5) $calc($5 + $7 - 2)

  drawline -rn $2 %gui.color2 1 $calc($4 + 1) $calc($5 + 1) $calc($4 + $6) $calc($5 + 1)
  drawline -rn $2 %gui.color2 1 $calc($4 + 1) $calc($5 + 1) $calc($4 + 1) $calc($5 + $7 - 1)

  drawline -rn $2 %gui.color1 1 $calc($4 + 1) $calc($5 + $7 - 1) $calc($4 + $6 - 6) $calc($5 + $7 - 1)
  drawline -rn $2 %gui.color1 1 $calc($4 + $6 - 6) $calc($5 + $7 - 1) $calc($4 + $6) $calc($5 + $7 - 7)
  drawline -rn $2 %gui.color1 1 $calc($4 + $6 - 1) $calc($5 + 1) $calc($4 + $6 - 1) $calc($5 + $7 - 6)

  var %gui.font = Verdana, %gui.fontSize = 11

  if ($hget(gui,$+($gui.short($2),.,$3,.font))) var %gui.font = $v1
  if ($hget(gui,$+($gui.short($2),.,$3,.fontSize))) var %gui.fontSize = $v1

  if ($wrap($8-,%gui.font,%gui.fontSize,$calc($6 - 15),1) != $8-) var %gui.text = $+($v1,...)
  else var %gui.text = $8-

  var %gui.x = $calc((($6 - $width(%gui.text,%gui.font,%gui.fontSize)) / 2) + $4)
  var %gui.y = $calc((($7 - $height(%gui.text,%gui.font,%gui.fontSize)) / 2) + $5)

  if ($1 == 2) { inc %gui.x | inc %gui.y }

  if ($gui.getInfo($gui.short($2),$3).hilight) var %gui.tcolor = $switch.hilight
  else var %gui.tcolor = $gui.color(text)

  drawtext -rn $2 $gui.color(textshadow) %gui.font %gui.fontSize $calc(%gui.x + 1) $calc(%gui.y + 1) %gui.text
  drawtext -rn $2 %gui.tcolor %gui.font %gui.fontSize %gui.x %gui.y %gui.text

  if (!$hget(gui,$+($gui.short($2),.stopDraw))) drawdot $2

  hadd gui $+($gui.short($2),.,$3,.text) %gui.text

}

alias gui.text {

  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.text: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) text
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.text) $6

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) gui.drawText %gui.window $2-

  }

}

alias -l gui.drawText {

  var %gui.compteur = 1, %gui.text
  var %gui.font = Verdana, %gui.fontSize = 11
  var %gui.height = $height(a,%gui.font,%gui.fontSize)

  drawrect -frn $1 $gui.color(bg) 1 $calc($2 - 1) $calc($3 + 1) $calc($4 + 2) $calc($5 + 2)

  while ($calc(%gui.compteur * %gui.height) < $5) && ($wrap($6-,%gui.font,%gui.fontSize,$4,%gui.compteur)) {
    var %gui.text = $v1

    var %gui.y = $calc(($3 - 10) + (%gui.compteur * (%gui.height + 2)))
    drawtext -rn $1 $gui.color(textshadow) %gui.font %gui.fontSize $calc($2 + 1) $calc(%gui.y + 1) %gui.text
    drawtext -rn $1 $gui.color(text) %gui.font %gui.fontSize $2 %gui.y %gui.text

    inc %gui.compteur
  }

  if (!$hget(gui,$+($gui.short($1),.stopDraw))) drawdot $1

}

alias gui.tbar {
  tokenize 9 $gui.getData2($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.tbar: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) tbar
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.sel) 0

    gui.drawTbar %gui.window $2-

  }
}

alias gui.drawTbar {

  drawrect -frn $1 $gui.color(bg) 1 $2-3 $calc($4 + 5) $calc($5 + 1)

  drawline -rn $1 $gui.color(shadow) 1 $2 $calc($3 + ($5 / 2)) $calc($2 + $4) $calc($3 + ($5 / 2))
  drawline -rn $1 $gui.color(hilight) 1 $2 $calc($3 + ($5 / 2) + 1) $calc($2 + $4) $calc($3 + ($5 / 2) + 1)

  var %gui.x = $calc($2 + ($4 - 13) * $6 / 100)

  drawline -rn $1 $gui.color(border) 1 $calc(%gui.x) $calc($3 + $5) $calc(%gui.x + 6) $calc($3 + $5) 
  drawline -rn $1 $gui.color(border) 1 $calc(%gui.x) $3 $calc(%gui.x) $calc($3 + $5)
  drawline -rn $1 $gui.color(border) 1 $calc(%gui.x) $3 $calc(%gui.x + 12) $3
  drawline -rn $1 $gui.color(border) 1 $calc(%gui.x + 12) $3 $calc(%gui.x + 12) $calc($3 + $5 - 6)
  drawline -rn $1 $gui.color(border) 1 $calc(%gui.x + 5) $calc($3 + $5) $calc(%gui.x + 12) $calc($3 + $5 - 7)

  drawline -rn $1 $gui.color(hcontrol) 1 $calc(%gui.x + 1) $calc($3 + 1) $calc(%gui.x + 12) $calc($3 + 1)
  drawline -rn $1 $gui.color(hcontrol) 1 $calc(%gui.x + 1) $calc($3 + 1) $calc(%gui.x + 1) $calc($3 + $5)

  var %gui.dline = $calc(%gui.x + 6) $calc($3 + $5 - 1)
  drawline -rn $1 $gui.color(scontrol) 1 $calc(%gui.x + 2) $calc($3 + $5 - 1) %gui.dline

  var %gui.dline = $calc(%gui.x + 12) $calc($3 + $5 - 8)
  drawline -rn $1 $gui.color(scontrol) 1 $calc(%gui.x + 5) $calc($3 + $5 - 1) %gui.dline
  drawline -rn $1 $gui.color(scontrol) 1 $calc(%gui.x + 11) $calc($3 + 1) $calc(%gui.x + 11) $calc($3 + $5 - 7)

  drawrect -frn $1 $gui.color(fcontrol) 1 $calc(%gui.x + 2) $calc($3 + 2) 4 $calc($5 - 3)

  var %gui.compteur = 6
  while (%gui.compteur <= 10) {
    var %gui.x2 = $calc(%gui.x + %gui.compteur)
    drawline -rn $1 $gui.color(fcontrol) 1 %gui.x2 $calc($3 + 2) %gui.x2 $calc($3 + $5 - (%gui.compteur - 4))
    inc %gui.compteur
  }

  if (!$hget(gui,$+($gui.short($1),.stopDraw))) drawdot $1

}

alias gui.check {
  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.check: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) check
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.text) $6-

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) {
      gui.drawSquare %gui.window $2-3
      gui.drawText %gui.window $calc($2 + 15) $calc($3 - 6) $calc($4 - 15) $5 $6-
    }

  }
}

;Used for checkbox
alias gui.drawSquare {
  drawrect -rn $1 $gui.color(border) 1 $2-3 12 12
  drawrect -rn $1 $gui.color(scontrol) 1 $calc($2 + 1) $calc($3 + 1) 10 10
  drawline -rn $1 $gui.color(hcontrol) 1 $calc($2 + 1) $calc($3 + 1) $calc($2 + 10) $calc($3 + 1)
  drawline -rn $1 $gui.color(hcontrol) 1 $calc($2 + 1) $calc($3 + 1) $calc($2 + 1) $calc($3 + 10)

  drawrect -frn $1 $gui.color(fcontrol) 1 $calc($2 + 2) $calc($3 + 2) 8 8
}

alias gui.box {
  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.box: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) box
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.text) $6-

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) gui.drawBox %gui.window $2-

  }
}

alias gui.drawBox {
  var %gui.font = Verdana, %gui.fontSize = 11

  if ($calc($width($6-,Verdana,11) + 8) > $calc($4 - 2)) { 
    var %gui.text = $+($wrap($6-,%gui.font,%gui.fontSize,$calc($4 -14),1),...)
  }
  else var %gui.text = $6-

  var %gui.wtext = $width(%gui.text,Verdana,11)

  drawrect -rnf $1 $gui.color(bg) 1 $2-5
  drawrect -rnf $1 $gui.color(fcontrol) 1 $2 $3 $calc(%gui.wtext +8) 20

  var %gui.dline = $calc($3 + 1) $calc($2 + 1) $calc($3 + 1) $calc($2 + 1) $calc($3 + 19)
  drawline -rn $1 $gui.color(hcontrol) 1 $calc($2 + 1) $calc($3 + 1) $calc($2 + %gui.wtext + 6) %gui.dline

  var %gui.dline = $calc($3 + 18) $calc($2 + %gui.wtext + 6) $calc($3 + 1)
  drawline -rn $1 $gui.color(scontrol) 1 $calc($2 + 1) $calc($3 + 18) $calc($2 + %gui.wtext + 6) %gui.dline

  var %gui.dline = $calc($2 + 1) $calc($3 + 20) $calc($2 + 1) $calc($3 + $5 - 2)
  var %gui.dline2 = $calc($2 + 1) $calc($3 + 20) $calc($2 + %gui.wtext + 8) $calc($3 + 20)
  var %gui.dline3 = $calc($2 + %gui.wtext + 8) $calc($3 + 1) $calc($2 + $4 - 2) $calc($3 + 1)
  drawline -rn $1 $gui.color(hilight) 1 %gui.dline %gui.dline2 %gui.dline3

  var %gui.dline = $calc($2 + $4 - 2) $calc($3 + $5 - 2) $calc($2 + $4 - 2) $calc($3 + 1)
  drawline -rn $1 $gui.color(shadow) 1 $calc($2 + 1) $calc($3 + $5 - 2) %gui.dline

  if (%gui.text) {
    drawtext -rn $1 $gui.color(hcontrol) %gui.font %gui.fontSize $calc($2 + 5) $calc($3 + 4) %gui.text
    drawtext -rn $1 $gui.color(text) %gui.font %gui.fontSize $calc($2 + 4) $calc($3 + 3) %gui.text
  }

  drawrect -rn $1 $gui.color(border) 1 $2 $3 $calc(%gui.wtext + 8) 20
  drawrect -rn $1 $gui.color(border) 1 $2-5

  if (!$hget(gui,$+($gui.short($1),.stopDraw))) drawdot $1
}

alias gui.pbar {
  tokenize 9 $gui.getData2($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.pbar: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) pbar
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5

    gui.drawPbar %gui.window $2-5

    if (!$hget(gui,$+($gui.short(%gui.window),.stopDraw))) drawdot %gui.window 
  }
}

/* 
 /gui.ajustPbar <window> <id> <percent>
 Ajust the progressbar to X percent
*/
alias gui.ajustPbar {
  var %gui.window = $+(@GUI.,$1)
  var %gui.percent = $3

  tokenize 32 $gui.getInfo($1,$2).position

  drawrect -rnf %gui.window $gui.color(bg) 1 $1-4
  gui.drawPbar %gui.window $1-4
  if (%gui.percent) {
    gui.squareLine %gui.window $calc($1 + 3) $calc($2 + 3) $calc(((%gui.percent + 1) * ($3 - 5)) / 100) $4
  }

  drawdot %gui.window
}

/* 
 /gui.drawPbar <window> <x y h w>
 Drawing the place of the progressbar
*/
alias -l gui.drawPbar {

  drawrect -rnf $1 $gui.color(fcontrol) 1 $2-5
  drawrect -rn $1 $gui.color(border) 1 $2-5

  var %gui.dline = $calc($2 + 1) $calc($3 + 1) $calc($2 + 1) $calc($3 + $5 - 2)
  drawline -rn $1 $gui.color(hcontrol) 1 $calc($2 + 1) $calc($3 + 1) $calc($2 + $4 - 2) $calc($3 + 1) %gui.dline

  var %gui.dline = $calc($3 + $5 - 2) $calc($2 + $4 - 2) $calc($3 + 1)
  drawline -rn $1 $gui.color(scontrol) 1 $calc($2 + 1) $calc($3 + $5 - 2) $calc($2 + $4 - 2) %gui.dline
}

/*
 /gui.squareLine <window> <x y h w>
 Do the progressbar squared line
*/
alias -l gui.squareLine {
  drawrect -rfn $1 $gui.color(scontrol) 1 $2 $3 $calc($4 - 2) $calc($5 - 6)

  var %gui.compteur = 1, %gui.nbLine = $floor($calc($4 / 4))
  while (%gui.compteur <= %gui.nbLine) { 
    if ($calc(%gui.compteur * 4 + %gui.compteur) < $4) {
      var %gui.x = $2 + $v1
      drawline -rn $1 $gui.color(fcontrol) 1 %gui.x $3 %gui.x $calc($3 + $5 - 6)
    }
    inc %gui.compteur 
  }
}

alias gui.combo {
  tokenize 9 $gui.getData2($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.combo: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) combo
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) {
      gui.drawCombo %gui.window $2-5
    }
  }
}

alias -l gui.drawCombo {
  var %gui.window = $1
  drawrect -rfn %gui.window $gui.color(fcontrol) 1 $2-5
  drawrect -rfn %gui.window $gui.color(bg) 1 $calc($2 + $4 - 11) $3 11 $5
  drawrect -rn %gui.window $gui.color(border) 1 $2-4 $5
  drawrect -rn %gui.window $gui.color(border) 1 $calc($2 + $4 - 11) $3 11 $5

  var %gui.dline = $calc($3 + 1) $calc($2 +1) $calc($3 +1) $calc($2 + 1) $calc($3 + $5 - 2)
  drawline -rn %gui.window $gui.color(hcontrol) 1 $calc($2 + 1) $calc($3 + 1) $calc($2 + $4 - 12) %gui.dline

  var %gui.dline = $calc($2 + $4 - 12) $calc($3 + $5 - 2) $calc($2 + $4 - 12) $calc($3 + 1)
  drawline -rn %gui.window $gui.color(scontrol) 1 $calc($2 + 1) $calc($3 + $5 - 2) %gui.dline

  var %gui.dline = $calc($2 + $4 - 10) $calc($3 + 1) $calc($2 + $4 - 2) $calc($3 + 1)
  var %gui.dline2 = $calc($2 + $4 - 10) $calc($3 + 1) $calc($2 + $4 - 10) $calc($3 + $5 - 2)
  drawline -rn %gui.window $gui.color(hilight) 1 %gui.dline %gui.dline2

  var %gui.dline = $calc($2 + $4 - 2) $calc($3 + $5 - 2) $calc($2 + $4 - 2) $calc($3 + 1)
  drawline -rn %gui.window $gui.color(shadow) 1 $calc($2 + $4 - 10) $calc($3 + $5 - 2) %gui.dline

  drawtext -rn %gui.window $gui.color(hilight) Terminal 10 $calc($2 + $4 - 8) $calc($3 + ($5 / 2) - 3 + 1) $chr(25)
  drawtext -rn %gui.window $gui.color(text) Terminal 10 $calc($2 + $4 - 9) $calc($3 + ($5 / 2) - 3) $chr(25)

  if (!$hget(gui,$+($gui.short(%gui.window),.stopDraw))) drawdot %gui.window
}

alias gui.edit {
  var %gui.prop = $gettok($1-,4,44)
  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)
  var %gui.name = $gui.short(%gui.window)

  if ($gui.checkId(%gui.name,$1)) echo -s * /gui.edit: id already exists
  else {

    hadd gui $+(%gui.name,.,$1,.type) edit
    hadd gui $+(%gui.name,.,$1,.position) $2-5
    hadd gui $+(%gui.name,.,$1,.text) $replace($6-,$chr(32),$chr(160))

    hadd gui $+(%gui.name,.,$1,.selPosition) 1
    hadd gui $+(%gui.name,.,$1,.cursorPosition) 1

    if (%gui.prop == password) hadd gui $+(%gui.name,.,$1,.password) 1

    if (!$gui.getInfo(%gui.name,$1).hide) {
      gui.drawListBorder %gui.window $2-5
      gui.changeFocus 1 %gui.name $1
      gui.edit.drawText 0 1 %gui.window
      if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot %gui.window
    }

  }
}

on *:keydown:@GUI.*:*:{

  var %gui.name = $gui.short($active)
  var %gui.id = $hget(gui,$+(%gui.name,.focus))
  var %gui.type = $gui.getInfo(%gui.name,%gui.id).type

  if ($keyval == 27) && ($active != @GUI.tool) && ($active != @GUI.switch) gui.close $gui.short($active)

  if (%gui.type == edit) {

    var %gui.oldTextSelection = $gui.getInfo(%gui.name,%gui.id).textSelection

    gui.setInfo %gui.name %gui.id oldTextSelection %gui.oldTextSelection
    gui.setInfo %gui.name %gui.id textSelection 0

    if ($keyval == 9) {
      ;Tab change the focus to the next editbox
      var %gui.oid = %gui.id + 1

      while ($hget(gui,$+(%gui.name,.,%gui.oid,.type))) {
        if ($v1 == edit) && (!$gui.getInfo(%gui.name,%gui.oid).hide) {
          gui.changeFocus 0 %gui.name %gui.oid
          $+(.timerGUI,%gui.name) -m 0 700 gui.focus $active

          break
        }
        inc %gui.oid

        if (%gui.id == %gui.oid) break

        if (!$hget(gui,$+(%gui.name,.,%gui.oid,.type))) var %gui.oid = 1

      }

    } 

    ; backspace
    elseif ($keyval == 8) {
      if (%gui.oldTextSelection) {
        gui.deleteSelectedText %gui.name %gui.id
      }
      else {
        var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition
        var %gui.text = $gui.getInfo(%gui.name,%gui.id).text

        if (%gui.selPosition > 2) {
          var %gui.text1 = $mid(%gui.text,1,$calc(%gui.selPosition - 2))
        }

        var %gui.text2 = $mid(%gui.text,%gui.selPosition)

        gui.setInfo %gui.name %gui.id text $+(%gui.text1,%gui.text2)
        gui.moveEditCursorLeft %gui.name %gui.id
      }

      .signal -n $+(GUI.,%gui.name) EDIT %gui.id $gui.getInfo(%gui.name,%gui.id).text

    }

    ; delete
    elseif ($keyval == 46) {
      if (%gui.oldTextSelection) {
        gui.deleteSelectedText %gui.name %gui.id
      }
      else {
        var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition
        var %gui.text = $gui.getInfo(%gui.name,%gui.id).text

        if (%gui.selPosition > 1) {
          var %gui.text1 = $mid(%gui.text,1,$calc(%gui.selPosition - 1))
        }
        var %gui.text2 = $mid(%gui.text,$calc(%gui.selPosition + 1))

        gui.setInfo %gui.name %gui.id text $+(%gui.text1,%gui.text2)
      }

      .signal -n $+(GUI.,%gui.name) EDIT %gui.id $gui.getInfo(%gui.name,%gui.id).text

    }

    ; enter
    elseif ($keyval == 13) return

    ; shift
    elseif ($keyval == 16) {
      gui.setInfo %gui.name %gui.id textSelection %gui.oldTextSelection

      hadd gui shiftDown 1

      ; Deselect the text when shift was pressed, does it cause a problem to remove it ?
      ;gui.setInfo %gui.name %gui.id selStart $gui.getInfo(%gui.name,%gui.id).selPosition
    }

    ; control
    elseif ($keyval == 17) {
      gui.setInfo %gui.name %gui.id textSelection %gui.oldTextSelection
      hadd gui $+(%gui.name,.,%gui.id,.ctrl) 1
    }

    ; escape
    elseif ($keyval == 27) {
      if ($active != @GUI.tool) && ($active != @GUI.switch) gui.close $gui.short($active)
    }

    ; left arrow
    elseif ($keyval == 37) {

      gui.moveEditCursorLeft %gui.name %gui.id

      ; select text with 'Shift + arrows'
      if ($hget(gui,shiftdown)) {
        var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition

        var %gui.newX = $gui.edit.getXFromCarPos(%gui.name,%gui.id,%gui.selPosition)
        gui.setInfo %gui.name %gui.id textSelection 1
        gui.setInfo %Gui.name %gui.id newCarretPosition %gui.selPosition
      }

    }

    ; end
    elseif ($keyval == 35) {
      var %gui.editWidth = $gettok($gui.getInfo(%gui.name,%gui.id).position,3,32)
      var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
      var %gui.dTextWidth = $calc($width(%gui.text,tahoma,11) - %gui.editWidth + 12)
      var %gui.pos = 1
      var %gui.firstCarWidth = $width($left(%gui.text,1),tahoma,11)

      if (%gui.dTextWidth >= %gui.firstCarWidth) {
        inc %gui.pos $len($wrap(%gui.text,tahoma,11,%gui.dTextWidth,0,1))
      }

      ; select text with 'Shift + end'
      if ($hget(gui,shiftdown)) {
        gui.setInfo %gui.name %gui.id textSelection 1
        gui.setInfo %gui.name %gui.id newCarretPosition $calc($len(%gui.text) + 1)
      }

      gui.setInfo %gui.name %gui.id selPosition $calc($len(%gui.text) + 1)
      gui.setInfo %gui.name %gui.id cursorPosition %gui.pos
    }

    ; home
    elseif ($keyval == 36) {

      ; select text with 'Shift + home'
      if ($hget(gui,shiftdown)) {
        gui.setInfo %gui.name %gui.id textSelection 1
        gui.setInfo %gui.name %gui.id newCarretPosition 1
      }

      gui.setInfo %gui.name %gui.id selPosition 1
      gui.setInfo %gui.name %gui.id cursorPosition 1
    }

    ; right arrow
    elseif ($keyval == 39) {

      gui.moveEditCursorRight %gui.name %gui.id

      ; select text with 'Shift + arrows'
      if ($hget(gui,shiftdown)) {
        var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition

        var %gui.newX = $gui.edit.getXFromCarPos(%gui.name,%gui.id,%gui.selPosition)
        gui.setInfo %gui.name %gui.id textSelection 1
        gui.setInfo %Gui.name %gui.id NewCarretPosition %gui.selPosition


      }

    }

    ; control+KEY
    elseif ($hget(gui,$+(%gui.name,.,%gui.id,.ctrl))) {

      ; select-all
      if ($keyval == 65) gui.edit.selectAll %gui.name %gui.id

      ; copy
      elseif ($keyval == 67) {
        gui.setInfo %gui.name %gui.id textSelection %gui.oldTextSelection
        if (%gui.oldTextSelection) {
          clipboard $gui.getInfo(%gui.name,%gui.id).selText
        }
      }

      ; paste
      elseif ($keyval == 86) {
        gui.edit.pasteClipboard %gui.name %gui.id
        return
      }

      ; cut
      elseif ($keyval == 88) {
        gui.edit.cutSelectedText %gui.name %gui.id %gui.oldTextSelection
      }

      ; undo
      if ($keyval == 90) gui.edit.undo %gui.name %gui.id

      ; don't handle those keys
      elseif ($keyval > 65) && ($keyval < 90) return

      ; other caracters
      else gui.edit.drawText 1 1 $active

    }
    elseif ($keyval == 192) hadd gui $+(%gui.name,.,%gui.id,.accent) 192
    elseif ($keyval == 219) hadd gui $+(%gui.name,.,%gui.id,.accent) 219
    elseif ($keyval == 221) hadd gui $+(%gui.name,.,%gui.id,.accent) 221

    elseif ($hget(gui,$+(%gui.name,.,%gui.id,.accent))) {

      gui.setInfo %gui.name %gui.id oldText $gui.getInfo(%gui.name,%gui.id).text

      var %gui.accent = $v1
      var %gui.code = $asc($keychar)

      if (%gui.maccent == 192) var %gui.char = `
      elseif (%gui.maccent == 219) var %gui.char = ^^
      elseif (%gui.maccent == 221) var %gui.char = 
      elseif (%gui.accent == 192) {
        if (%gui.code == 65) var %gui.char = 
        elseif (%gui.code == 69) var %gui.char = 
        elseif (%gui.code == 73) var %gui.char = 
        elseif (%gui.code == 97) var %gui.char = 
        elseif (%gui.code == 101) var %gui.char = 
        elseif (%gui.code == 105) var %gui.char = 
      }

      elseif (%gui.accent == 219) {
        if (%gui.code == 65) var %gui.char = 
        elseif (%gui.code == 69) var %gui.char = 
        elseif (%gui.code == 73) var %gui.char = 
        elseif (%gui.code == 97) var %gui.char = 
        elseif (%gui.code == 101) var %gui.char = 
        elseif (%gui.code == 105) var %gui.char = 
      }

      elseif (%gui.accent == 221) {
        if (%gui.code == 69) var %gui.char = 
        elseif (%gui.code == 101) var %gui.char = 
      }

      var %gui.selPosition = $gui.getInfo(%Gui.name,%gui.id).selPosition
      var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
      var %gui.newText

      if (%gui.selPosition > 2) {
        %gui.newText = $mid(%gui.text,1,$calc(%gui.selPosition - 1))
      }

      %gui.newText = $+(%gui.newText,%gui.char,$mid(%gui.text,%gui.selPosition))
      gui.setInfo %gui.name %gui.id text %gui.newText
      gui.edit.drawText 1 0 $active
      hdel gui $+(%gui.name,.,%gui.id,.accent)
    }
    elseif ($hget(gui,$+($gui.short($active),.focus))) {
      gui.setInfo %gui.name %gui.id oldText $gui.getInfo(%gui.name,%gui.id).text
      gui.edit.drawText 1 1 $active 
    }

    gui.focus $active 1

  }

  if (%gui.type == ilview) {

    var %gui.refresh
    var %gui.sX = $gui.getInfo(%gui.name,%gui.id).sX
    var %gui.sY = $gui.getInfo(%gui.name,%gui.id).sY

    ; up
    if ($keyval == 38) {
      if (%gui.sY > 1) {
        hadd gui $+(%gui.name,.,%gui.id,.sY) $calc($v1 - 1)
        %gui.refresh = 1
      }
    }

    ; down
    if ($keyval == 40) {
      if (%gui.sY < $calc($gui.getInfo(%gui.name,%gui.id).lines - 1)) {
        hadd gui $+(%gui.name,.,%gui.id,.sY) $calc($v1 + 1)
        %gui.refresh = 1
      }
    }

    ; left
    if ($keyval == 37) {
      if (%gui.sX > 1) {
        hadd gui $+(%gui.name,.,%gui.id,.sX) $calc($v1 - 1)
        %gui.refresh = 1
      }
    }

    ; right
    if ($keyval == 39) {
      if (%gui.sX < $gui.getInfo(%gui.name,%gui.id).rows) {
        hadd gui $+(%gui.name,.,%gui.id,.sX) $calc($v1 + 1)
        %gui.refresh = 1
      }
    }

    %gui.sX = $gui.getInfo(%gui.name,%gui.id).sX
    %gui.sY = $gui.getInfo(%gui.name,%gui.id).sY

    if (%gui.refresh) {
      tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

      gui.drawIlview %gui.name %gui.id
      gui.drawSelectedIlview $1 $2 %gui.name %gui.id %gui.sX %gui.sY
    }

  }

  elseif (%gui.type == list) || (%gui.type == lview) || (%gui.type == tview) {
    if ($keyval == 38) {  
      tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

      if (%gui.type == lview) var %gui.hHeight = 22
      else var %gui.hHeight = 10

      var %gui.height = $height(a,Verdana,11) + 2
      var %gui.maxitem = $floor($calc(($4 - %gui.hHeight) / %gui.height))

      if (%gui.type == list) || (%gui.type == lview) || (%gui.type == tview) {
        var %gui.htable = $+(%gui.name,.,%gui.id,.sel)

        if ($hget(gui,%gui.htable) > 1) { 

          var %gui.sposition = $hget(gui,$+(%gui.name,.,%gui.id,.sposition))
          var %gui.sel = $hget(gui,%gui.htable)

          if ($calc(%gui.sel - %gui.sposition) < 0) || ($calc(%gui.sel - %gui.sposition) > %gui.maxItem) {
            if ($calc($hget(gui,%gui.htable) - 1) > $calc($gdid(%gui.name,%gui.id).lines - %gui.maxItem)) {
              hadd gui $+(%gui.name,.,%gui.id,.sposition) $v2
            }
            else hadd gui $+(%gui.name,.,%gui.id,.sposition) $calc($hget(gui,%gui.htable) - 1)
          }
          elseif ($calc(%gui.sel - %gui.sposition) == 0) hdec gui $+(%gui.name,.,%gui.id,.sposition)

          hdec gui %gui.htable 

          if (%gui.type == list) gui.drawList %gui.name %gui.id
          elseif (%gui.type == lview) gui.drawListView %gui.name %gui.id 
          elseif (%gui.type == tview) gui.drawTreeView %gui.name %gui.id

          .signal -n $+(GUI.,%gui.name) SCROLL %gui.id
          .signal -n $+(GUI.,%gui.name) SCLICK %gui.id

        }

      }
    }
    elseif ($keyval == 40) {
      tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

      if (%gui.type == lview) var %gui.hHeight = 22
      else var %gui.hHeight = 10

      var %gui.height = $height(a,Verdana,11) + 2
      var %gui.maxitem = $floor($calc(($4 - %gui.hHeight) / %gui.height))

      if (%gui.type == list) || (%gui.type == lview) || (%gui.type == tview) {
        var %gui.htable = $+(%gui.name,.,%gui.id,.sel)

        if ($hget(gui,%gui.htable) < $gdid(%gui.name,%gui.id).lines) {

          var %gui.sposition = $hget(gui,$+(%gui.name,.,%gui.id,.sposition))
          var %gui.sel = $hget(gui,%gui.htable)

          if ($calc(%gui.sel - %gui.sposition) < 0) || ($calc(%gui.sel - %gui.sposition) > %gui.maxItem) {
            hadd gui $+(%gui.name,.,%gui.id,.sposition) $calc($hget(gui,%gui.htable) + 1)
          }
          elseif ($calc(%gui.sel - %gui.sposition + 1) >= %gui.maxitem) hinc gui $+(%gui.name,.,%gui.id,.sposition)

          hinc gui %gui.htable 

          if (%gui.type == list) gui.drawList %gui.name %gui.id
          elseif (%gui.type == lview) gui.drawListView %gui.name %gui.id 
          elseif (%gui.type == tview) gui.drawTreeView %gui.name %gui.id

          .signal -n $+(GUI.,%gui.name) SCROLL %gui.id
          .signal -n $+(GUI.,%gui.name) SCLICK %gui.id

        }

      }
    }

  }

}

on *:keyup:@GUI.*:*:{

  ; shift
  if ($keyval == 16) {
    hadd gui shiftDown 0
    gui.setInfo %gui.name %gui.id textSelection 0
  }

  ; ctrl
  elseif ($keyval == 17) || ($keyval == 18) {
    var %gui.name = $gui.short($active)
    var %gui.id = $hget(gui,$+(%gui.name,.focus))

    hdel gui $+(%gui.name,.,%gui.id,.ctrl)
  }

}

alias gui.edit.drawText {

  var %gui.signal = $1
  var %gui.update = $2
  var %gui.window = $3
  var %gui.name = $gui.short($3)
  var %gui.id = $hget(gui,$+(%gui.name,.focus))
  var %gui.font = Tahoma, %gui.fontSize = 11

  var %gui.oldTextSelection = $gui.getInfo(%gui.name,%gui.id).oldTextSelection

  ; remove the selection when a key is pressed
  gui.setInfo %gui.name %gui.id textSelection 0

  tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

  var %gui.htable = $+(%gui.name,.,%gui.id,.text)
  var %gui.text = $hget(gui,%gui.htable)

  ; other caracters
  if ($keyval) {

    ; Limit of 929 caracters in an editbox (hash table limitation)
    if ($len($hget(gui,$+(%gui.name,.,%gui.id,.text))) == 929) return

    ; erase the selected text
    if ($gui.getInfo(%gui.name,%gui.id).OldTextSelection) {
      gui.deleteSelectedText %gui.name %gui.id
    }

    var %gui.text = $hget(gui,%gui.htable)
    var %gui.selPosition = $calc($gui.getInfo(%gui.name,%gui.id).selPosition - 1)
    var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition
    var %gui.fTextWidth = $width($mid(%gui.text,%gui.cursorPosition),Tahoma,11)

    if (%gui.selPosition) var %gui.text1 = $mid(%gui.text,1,%gui.selPosition)

    var %gui.text2 = $mid(%gui.text,$calc(%gui.selPosition + 1))

    gui.setInfo %gui.name %gui.id selPosition $calc(%gui.selPosition + 2)

    var %gui.cursorX = $calc($gui.getInfo(%gui.name,%gui.id).cursorX - $1)

    ; check if the text is longer then the edit, if it's the case, we add one to the cursor
    if (%gui.cursorX > $calc($3 - 15)) {
      gui.setInfo %gui.name %gui.id cursorPosition $calc(%gui.cursorPosition + 1)
    }

    var %gui.keychar = $chr($replace($asc($keychar),32,160))
    var %gui.newText = $+(%gui.text1,$iif(%gui.update,%gui.keychar),%gui.text2)

    hadd gui %gui.htable %gui.newText
  }

  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text

  if ($gui.getInfo(%gui.name,%gui.id).password) %gui.text = $str(*,$len(%gui.text))

  ; clear the edit box 
  drawrect -frn %gui.window $gui.color(hilight) 1 $calc($1 + 2) $calc($2 + 2) $calc($3 - 4) $calc($4 - 4)

  ; if the edit have text
  if ($len(%gui.text)) {

    ; position of the cursor in the edit (on screen)
    var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition

    ; text to be displayed in the edit
    var %gui.fText = $wrap($mid(%gui.text,%gui.cursorPosition),Tahoma,11,$calc($3 - 2),0,1)

    if ($len(%gui.fText)) drawtext -rn %gui.window $gui.color(text) Tahoma 11 $calc($1 + 3) $calc($2 + 2) %gui.fText
  }

  if (%gui.signal) .signal -n $+(GUI.,%gui.name) EDIT %gui.id %gui.text
  if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot %gui.window

}

; /gui.deleteSelectedText <name> <id>
alias gui.deleteSelectedText {

  var %gui.name = $1, %gui.id = $2
  var %gui.selStart = $gui.getInfo(%gui.name,%gui.id).curStart
  var %gui.selEnd = $gui.getInfo(%gui.name,%gui.id).curEnd
  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text

  gui.setInfo %gui.name %gui.id selPosition %gui.selStart
  var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition

  if (%gui.cursorPosition > 1) {
    dec %gui.cursorPosition $calc(%gui.selEnd - %gui.selStart)
    if (%gui.cursorPosition < 1) %gui.cursorPosition = 1
    gui.setInfo %gui.name %gui.id cursorPosition %gui.cursorPosition
  }

  var %gui.newText
  var %gui.start = $calc(%gui.selStart - 1)
  if (%gui.start > 0) {
    %gui.newText = $mid(%gui.text,1,%gui.start)
  }

  %gui.newText = $+(%gui.newText,$mid(%gui.text,%gui.selEnd))
  gui.setInfo %gui.name %gui.id text %gui.newText
}

; /gui.moveEditCursorLeft <name> <id>
alias gui.MoveEditCursorLeft {
  var %gui.name = $1, %gui.id = $2
  var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition
  var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition
  var %gui.onEditPosition = $calc(%gui.selPosition - %gui.cursorPosition)

  ; if we are goin from the second caracter to the first
  if (%gui.onEditPosition < 2) {

    if ($calc(%gui.selPosition - 4) > 0) {
      dec %gui.cursorPosition 4
      dec %gui.selPosition
    }
    else {
      %gui.cursorPosition = 1
      %gui.selPosition = 1
    }
  }
  else {
    dec %gui.selPosition
  }

  gui.setInfo %gui.name %gui.id cursorPosition %gui.cursorPosition
  gui.setInfo %gui.name %gui.id selPosition %gui.selPosition
}

; /gui.moveEditCursorRight <name> <id>
alias gui.moveEditCursorRight {
  var %gui.name = $1, %gui.id = $2
  tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

  var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition
  var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition

  var %gui.onEditPosition = $calc(%gui.selPosition - %gui.cursorPosition)
  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
  var %gui.maxChars = $len($wrap($mid(%gui.text,%gui.cursorPosition),Tahoma,11,$calc($3 - 5),0,1))

  ; if it's the end of the edit (and NOT the text)
  if (%gui.onEditPosition >= $calc(%gui.maxChars - 1)) {

    ; if it has enough caracters in the text to skip 4
    if ($calc(%gui.selPosition + 4) <= $len(%Gui.Text)) {
      inc %gui.cursorPosition 4
      inc %gui.selPosition 1
    }
    else {
      inc %gui.selPosition
      if (%Gui.selPosition > $calc($len(%gui.text) + 1)) %gui.selPosition = $v2
      inc %gui.cursorPosition $calc(%gui.selPosition - %gui.cursorPosition - %gui.maxChars)
    }
  }
  else inc %gui.selPosition

  gui.setInfo %gui.name %gui.id cursorPosition %gui.cursorPosition
  gui.setInfo %gui.name %gui.id selPosition %gui.selPosition
}

alias gui.focus {
  var %gui.window = $1
  var %gui.parmShowCursor = $2
  var %gui.name = $right($1,-5)
  var %gui.id = $hget(gui,$+(%gui.name,.focus))

  if ($active == $1) && (%gui.id) && ($gui.getInfo(%gui.name,%gui.id).type == edit) {
    tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

    ; position of the cursor in the string
    var %gui.position = $gui.getInfo(%gui.name,%gui.id).position

    ; position of the cursor in the edit (on screen)
    var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition

    ; position of the cursor in the text
    var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition

    ; position of the cursor in the visible part of the edit
    var %gui.onEditPosition = $calc(%gui.selPosition - %gui.cursorPosition)

    var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
    if ($gui.getInfo(%gui.name,%gui.id).password) %gui.text = $str(*,$len(%gui.text))

    ; clear the edit box 
    drawrect -frn %gui.window $gui.color(hilight) 1 $1 $2 $3 $4
    gui.drawListBorder %gui.window $1 $2 $3 $4

    ; position of the "flashing" cursor
    var %gui.cursorX = $calc($1 + 2)

    ; if the edit have text
    if ($len(%gui.text)) {

      ; text to be displayed in the edit
      var %gui.fText = $wrap($mid(%gui.text,%gui.cursorPosition),Tahoma,11,$calc($3 - 2),0,1)

      if (%gui.onEditPosition) {
        var %gui.fText2 = $mid(%gui.fText,1,%gui.onEditPosition)
        inc %gui.cursorX $width(%gui.fText2,Tahoma,11)
      }

      drawtext -rn %gui.window $gui.color(text) Tahoma 11 $calc($1 + 3) $calc($2 + 2) %gui.ftext

    }

    ; save the position of the cursor
    gui.setInfo %gui.name %gui.id CursorX %gui.cursorX

    var %gui.showCursor = $gui.getInfo(%gui.name,%gui.id).showCursor

    var %gui.lastCursorFlash = $gui.getInfo(%gui.name,%gui.id).lastCursorFlash

    ; if the interval is elapsed, we change the state of the cursor
    if ($calc($ticks - %gui.lastCursorFlash) >= $hget(config,gui.cursorFlashInterval)) {
      gui.setInfo %gui.name %gui.id lastCursorFlash $ticks
      gui.setInfo %gui.name %gui.id showCursor $abs($calc(%gui.showCursor - 1))
    }

    ; if we specifie that the cursor need to be draw
    if (%gui.parmShowCursor) {
      gui.setInfo %gui.name %gui.id showCursor 1
    }

    var %gui.cursorX = $gui.edit.getXFromCarPos(%gui.name,%gui.id,%gui.selPosition)
    var %gui.textSelection = $gui.getInfo(%gui.name,%gui.id).textSelection

    ; we redraw the cursor is %gui.showCursor is set (by the timer, ticks, etc) and if no selection is made
    if ((%gui.showCursor && !%gui.textSelection) || (%gui.parmShowCursor && !%gui.textSelection)) {
      drawline -rn %gui.window $gui.color(border) 1 %gui.cursorX $calc($2 + 3) %gui.cursorX $calc($2 + $4 - 4)
    }

    ; the selected text
    var %selText

    ; the selection of the text
    if (%gui.textSelection) {
      var %gui.cursorX = $gui.getInfo(%gui.name,%gui.id).selStart
      var %gui.cursorX2 = $gui.getInfo(%gui.name,%gui.id).newCarretPosition 
      var %temp = %gui.cursorX2

      if (%gui.cursorX2 < %gui.cursorX) {
        %gui.cursorX2 = %gui.cursorX
        %gui.cursorX = %temp
      }

      var %gui.selStart = %gui.cursorX
      var %gui.selEnd = %gui.cursorX2

      gui.setInfo %gui.name %gui.id curStart %gui.selStart
      gui.setInfo %gui.name %gui.id curEnd %gui.selEnd

      %gui.cursorX = $gui.edit.getXFromCarPos(%gui.name,%gui.id,%gui.cursorX)

      var %gui.cursorX2 = $gui.edit.getXFromCarPos(%gui.name,%gui.id,%gui.cursorx2)

      if (%gui.cursorX < $calc($1 + 2)) %gui.cursorX = $v2
      if (%gui.cursorX2 > $calc($1 + $3 - 2)) %gui.cursorX2 = $v2

      ; set the selected text
      %selText = $mid(%gui.text,%gui.selStart,$calc(%gui.selEnd - %gui.selStart))

      var %gui.SelWidth = $calc(%gui.cursorx2 - %gui.cursorx)

      drawrect -nrfi %gui.window $rgb(0,0,0) 1 %gui.cursorX $calc($2 + 2) %gui.selWidth $calc($4 - 4)

    }

    gui.setInfo %gui.name %gui.id selText %selText

    if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot %gui.window
  }
}

/*
 Return the position X where is located the caracter N in the edit id on the window win
 if the caracter is not visible (outside the visible part of the edit), the returned value
 will be 2(relative) or X+2(absolute) if the caracter is before, else the returned value will be W-2(absolute) 
 ou X+W-2(relative) (-2 is for the edit border) if the caracter is after the edit

 parameters: win_name edit_id car_pos

 prop: relative -> return the relative position to the edit
    absolute -> return the absolute position
*/
alias gui.edit.getXFromCarPos {
  var %gui.name = $1
  var %gui.id = $2
  var %gui.sel = $3

  tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

  var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition
  var %gui.selPosition = $gui.getInfo(%gui.name,%gui.id).selPosition
  var %gui.onEditPosition = $calc(%gui.selPosition - %gui.cursorPosition)

  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
  if ($gui.getInfo(%gui.name,%gui.id).password) %gui.text = $str(*,$len(%gui.text))

  var %gui.len = $calc(%gui.sel - %gui.cursorPosition)
  var %gui.fText

  if (%gui.len > 0) {
    %gui.fText = $mid(%gui.text,%gui.cursorPosition,%gui.len)
  }

  var %gui.x = $width(%gui.fText,Tahoma,11)
  if (!$len(%gui.x)) %gui.x = 0

  if (%gui.x > $calc($3 - 4)) %gui.x = $calc($3 - 4)
  if (!$prop) || ($prop == absolute) inc %gui.x $1
  inc %gui.x 2

  return %gui.x
}

/*
 Return the position of the caracter at the coord X
 parameters: win_name edit_id coord_x

 prop: relative -> return the relative position to the edit
    absolute -> return the absolute position
*/

alias gui.edit.getCarPosFromX {
  var %gui.name = $1
  var %gui.id = $2
  var %x = $3
  tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

  var %gui.click = $calc(%x - $1 - 2)
  var %gui.cursorPosition = $gui.getInfo(%gui.name,%gui.id).cursorPosition

  var %gui.text = $gui.getInfo(%gui.name,%gui.id).text
  if ($gui.getInfo(%gui.name,%gui.id).password) %gui.text = $str(*,$len(%gui.text))

  var %gui.onScreenText = $mid(%gui.text,%gui.cursorPosition)

  var %gui.wrap = $wrap(%gui.onScreenText,Tahoma,11,%gui.click,0,1)
  var %gui.wrapW = $width(%gui.wrap,Tahoma,11)
  var %gui.lastCar = $mid(%gui.onScreenText,$calc($len(%gui.wrap) + 1),1)

  var %gui.selPos = $calc(%gui.cursorPosition + $len(%gui.wrap))

  var %gui.lastCarCheck = $int($calc($width(%gui.lastCar,Tahoma,11) / 2))
  if (%gui.click > $calc(%gui.wrapW + %gui.lastCarCheck)) {
    inc %gui.selPos
  }

  if (%gui.click < %gui.wrapW) %gui.selPos = 1

  if ($prop == relative) dec %gui.selPos $calc(%gui.cursorPosition - 1)

  return %gui.selPos
}


alias gui.changeFocus { 

  $+(.timerGUI,$2) off

  if ($gui.getInfo($2,$hget(gui,$+($2,.focus))).type == edit) gui.edit.drawText 0 $1 $+(@GUI.,$2)

  hadd gui $+($2,.focus) $3 

  $+(.timerGUI,$2) -m 0 700 gui.focus $2

}

alias gui.radio {

  tokenize 9 $gui.getData3($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.radio: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) radio
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.text) $6
    hadd gui $+($gui.short(%gui.window),.,$1,.group) $iif($7,$7,group 1)

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) {
      gui.drawRadio %gui.window $2-3
      gui.drawText %gui.window $calc($2 + 15) $calc($3 - 6) $calc($4 - 15) $5 $6
    }

  }

}

alias -l gui.drawRadio {
  drawrect -rne $1 $gui.color(border) 1 $2-3 11 11
  drawrect -rne $1 $gui.color(scontrol) 1 $calc($2 + 1) $calc($3 + 1) 9 9
  drawrect -frne $1 $gui.color(fcontrol) 1 $calc($2 + 2) $calc($3 + 2) 7 7
}

alias gui.list {

  tokenize 9 $gui.getData2($1-)

  var %gui.window = $hget(gui,lastcreated)
  var %gui.name = $gui.short(%gui.window)

  if ($gui.checkId(%gui.name,$1)) echo -s * /gui.list: id already exists
  else {

    hadd gui $+(%gui.name,.,$1,.type) list
    hadd gui $+(%gui.name,.,$1,.position) $2-5
    hadd gui $+(%gui.name,.,$1,.sposition) 1

    if (!$gui.getInfo(%gui.name,$1).hide) {
      gui.drawListBorder %gui.window $2-5
      gui.drawScroll %gui.window $1 $calc($2 + $4 - 17) $calc($3 + 3) 14 $calc($5 - 6)

      if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot %gui.window
    }

  }

}

alias -l gui.drawListBorder {
  drawrect -rn $1 $gui.color(border) 1 $2-5
  drawrect -rn $1 $gui.color(shadow) 1 $calc($2 + 1) $calc($3 + 1) $calc($4 - 2) $calc($5 - 2)

  drawrect -frn $1 $gui.color(hilight) 1 $calc($2 + 2) $calc($3 + 2) $calc($4 - 4) $calc($5 - 4)
}

alias gui.drawList {

  var %gui.name = $1, %gui.id = $2
  tokenize 32 $gui.getInfo($1,$2).position

  var %gui.compteur = $gui.getInfo(%gui.name,%gui.id).sposition, %gui.y = $2 + 5
  var %gui.height = $calc($height(a,Verdana,11) + 2)
  var %gui.maxitem = $calc(($4 - 10) / %gui.height), %gui.nbitem = 1

  drawrect -frn $+(@GUI.,%gui.name) $gui.color(hilight) 1 $calc($1 + 2) $calc($2 + 3) $calc($3 - 20) $calc($4 - 5)

  while (%gui.nbitem <= %gui.maxitem) && ($hget(gui,$+(%gui.name,.,%gui.id,.litem.,%gui.compteur))) {
    var %gui.item = $v1

    ;Wrap text that are longer than the list width
    if ($width(%gui.item,Verdana,11) > $calc($3 - 32)) {
      %gui.item = $+($wrap(%gui.item,Verdana,11,$calc($3 - 32),0,1),...)
    }

    if (%gui.compteur == $gui.getInfo(%gui.name,%gui.id).sel) {
      drawrect -rn $+(@GUI.,%gui.name) $gui.color(scontrol) 1 $calc($1 + 3) %gui.y $calc($3 - 22) $calc(%gui.height - 1)
      var %gui.dline = $calc($3 - 24) $calc(%gui.height - 3)
      drawrect -frn $+(@GUI.,%gui.name) $gui.color(fcontrol) 1 $calc($1 + 4) $calc(%gui.y + 1) %gui.dline

      drawtext -rn $+(@GUI.,%gui.name) $gui.color(textshadow) Verdana 11 $calc($1 + 7) $calc(%gui.y + 1) %gui.item
      drawtext -rn $+(@GUI.,%gui.name) $gui.color(text) Verdana 11 $calc($1 + 6) %gui.y %gui.item
    }
    else drawtext -rn $+(@GUI.,%gui.name) $gui.color(text) Verdana 11 $calc($1 + 6) %gui.y %gui.item

    inc %gui.nbitem
    inc %gui.y %gui.height
    inc %gui.compteur

  }

  gui.drawScrollThumb %gui.name %gui.id

  if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot $+(@GUI.,%gui.name)

}

;/gui.drawScroll <window> <id> <x y w h>
alias gui.drawScroll {

  drawrect -rn $1 $gui.color(border) 1 $3-6
  drawline -rn $1 $gui.color(border) 1 $3 $calc($4 + 12) $calc($3 + $5) $calc($4 + 12)
  drawline -rn $1 $gui.color(border) 1 $3 $calc($4 + $6 - 13) $calc($3 + $5) $calc($4 + $6 - 13)

  if ($gui.getInfo($gui.short($1),$2).uScroll) var %gui.color1 = hilight, %gui.color2 = shadow
  else var %gui.color1 = shadow, %gui.color2 = hilight

  drawrect -frn $1 $gui.color(bg) 1 $calc($3 + 1) $calc($4 + 1) $calc($5 - 2) 11
  drawrect -rn $1 $gui.color(%gui.color1) 1 $calc($3 + 1) $calc($4 + 1) $calc($5 - 2) 11
  drawline -rn $1 $gui.color(%gui.color2) 1 $calc($3 + 1) $calc($4 + 1) $calc($3 + $5 - 1) $calc($4 + 1)
  drawline -rn $1 $gui.color(%gui.color2) 1 $calc($3 + 1) $calc($4 + 1) $calc($3 + 1) $calc($4 + 12)

  if ($gui.getInfo($gui.short($1),$2).dScroll) var %gui.color1 = hilight, %gui.color2 = shadow
  else var %gui.color1 = shadow, %gui.color2 = hilight

  drawrect -frn $1 $gui.color(bg) 1 $calc($3 + 1) $calc($4 + $6 - 12) $calc($5 - 2) 11
  drawrect -rn $1 $gui.color(%gui.color1) 1 $calc($3 + 1) $calc($4 + $6 - 12) $calc($5 - 2) 11
  drawline -rn $1 $gui.color(%gui.color2) 1 $calc($3 + 1) $calc($4 + $6 - 12) $calc($3 + $5 - 1) $calc($4 + $6 - 12)
  drawline -rn $1 $gui.color(%gui.color2) 1 $calc($3 + 1) $calc($4 + $6 - 12) $calc($3 + 1) $calc($4 + $6 - 1)

  drawrect -frn $1 $gui.color(fcontrol) 1 $calc($3 + 1) $calc($4 + 13) $calc($5 - 2) $calc($6 - 26)
  drawrect -rn $1 $gui.color(scontrol) 1 $calc($3 + 1) $calc($4 + 13) $calc($5 - 2) $calc($6 - 26)
  drawline -rn $1 $gui.color(hcontrol) 1 $calc($3 + 1) $calc($4 + 13) $calc($3 + $5 - 1) $calc($4 + 13)
  drawline -rn $1 $gui.color(hcontrol) 1 $calc($3 + 1) $calc($4 + 13) $calc($3 + 1) $calc($4 + $6 - 13)

}

alias gui.drawScrollThumb {

  var %gui.name = $1
  var %gui.id = $2
  var %gui.window = $+(@GUI.,%gui.name)

  tokenize 32 $gui.getInfo($1,$2).position

  if ($gui.getInfo(%gui.name,%gui.id).type == lview) var %gui.rHeight = 22
  else var %gui.rHeight = 10

  var %gui.height = $height(a,Verdana,11) + 2
  var %gui.maxItem = $floor($calc(($4 - %gui.rHeight) / %gui.height))
  var %gui.position = $hget(gui,$+(%gui.name,.,%gui.id,.sposition))
  var %gui.nbItems = $gdid(%gui.name,%gui.id).lines

  if (%gui.nbItems <= %gui.maxItem) return

  var %gui.height = $4 - 32
  var %gui.tHeight = $calc(%gui.maxItem / %gui.nbItems * %gui.height + 1)

  if (%gui.tHeight < 8) {
    var %gui.otHeight = $int(%gui.tHeight)
    %gui.tHeight = 8
    dec %gui.height $calc(%gui.tHeight - %gui.otHeight)
  }

  if (!%gui.nbItems) return

  var %gui.tY = $calc(((%gui.position - 1) / %gui.nbItems * %gui.height) + 16 + $2)

  hadd gui $+(%gui.name,.,%gui.id,.scrollY) %gui.tY
  hadd gui $+(%gui.name,.,%gui.id,.scrollH) %gui.tHeight

  var %gui.x = $calc($1 + $3 - 16), %gui.y = $calc(%gui.tY + 1)

  drawrect -frn %gui.window $gui.color(fcontrol) 1 %gui.x $calc($2 + 16) 12 $calc($4 - 32)
  drawrect -frn %gui.window $gui.color(border) 1 %gui.x %gui.tY 12 %gui.tHeight
  drawrect -rn %gui.window $gui.color(shadow) 1 %gui.x %gui.y 12 $calc(%gui.tHeight - 2)
  drawline -rn %gui.window $gui.color(hilight) 1 %gui.x %gui.y %gui.x $calc(%gui.tY + %gui.tHeight - 2)
  drawline -rn %gui.window $gui.color(hilight) 1 $calc($1 + $3 - 15) %gui.y $calc($1 + $3 - 4) %gui.y 
  drawrect -frn %gui.window $gui.color(bg) 1 $calc($1 + $3 - 15) $calc(%gui.tY + 2) 10 $calc(%gui.tHeight - 4)

  drawdot %gui.window
}

alias gui.lview {

  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.lview: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) lview
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.colonne) $6-
    hadd gui $+($gui.short(%gui.window),.,$1,.sposition) 1

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) {
      drawrect -rn %gui.window $gui.color(border) 1 $2-5
      drawrect -rn %gui.window $gui.color(shadow) 1 $calc($2 + 1) $calc($3 + 1) $calc($4 - 2) $calc($5 - 2)

      drawrect -frn %gui.window $gui.color(hilight) 1 $calc($2 + 2) $calc($3 + 2) $calc($4 - 4) $calc($5 - 4)

      gui.drawScroll %gui.window $1 $calc($2 + $4 - 17) $calc($3 + 3) 14 $calc($5 - 6)

      gui.drawLviewHeaders %gui.window $2-

      if (!$hget(gui,$+($gui.short(%gui.window),.stopDraw))) drawdot %gui.window
    }

  }

}

alias gui.drawLviewHeaders {
  var %gui.compteur = 2, %gui.x = $2 + 3
  while ($gettok($6-,%gui.compteur,8)) {
    var %gui.width = $v1

    var %gui.dline = 1 $calc(%gui.x + 1) $calc($3 + 4)
    drawrect -rn $1 $gui.color(border) 1 %gui.x $calc($3 + 3) %gui.width 18
    drawrect -frn $1 $gui.color(fcontrol) %gui.dline $calc(%gui.width - 2) 16
    drawrect -rn $1 $gui.color(scontrol) %gui.dline $calc(%gui.width - 2) 16
    drawline -rn $1 $gui.color(hcontrol) %gui.dline $calc(%gui.x + %gui.width - 1) $calc($3 + 4)
    drawline -rn $1 $gui.color(hcontrol) %gui.dline $calc(%gui.x + 1) $calc($3 + 20)

    var %gui.text = $gettok($6-,$calc(%gui.compteur - 1),8)
    drawtext -rn $1 $gui.color(textshadow) Verdana 11 $calc(%gui.x + 5) $calc($3 + 6) %gui.text
    drawtext -rn $1 $gui.color(text) Verdana 11 $calc(%gui.x + 4) $calc($3 + 5) %gui.text

    inc %gui.x $calc(%gui.width - 1)
    inc %gui.compteur 2
  }
}

alias gui.drawListView {

  var %gui.name = $1, %gui.id = $2
  tokenize 32 $gui.getInfo($1,$2).position

  var %gui.compteur = $gui.getInfo(%gui.name,%gui.id).sposition, %gui.y = $2 + 22
  var %gui.height = $calc($height(a,Verdana,11) + 2)
  var %gui.maxitem = $calc(($4 - 22) / %gui.height), %gui.nbitem = 1

  drawrect -frn $+(@GUI.,%gui.name) $gui.color(hilight) 1 $calc($1 + 2) $calc($2 + 21) $calc($3 - 20) $calc($4 - 24)

  while (%gui.nbitem <= %gui.maxitem) && ($hget(gui,$+(%gui.name,.,%gui.id,.lvitem.,%gui.compteur))) {
    var %gui.item = $v1

    ;If the current line is the selected line
    if (%gui.compteur == $gui.getInfo(%gui.name,%gui.id).sel) {
      drawrect -rn $+(@GUI.,%gui.name) $gui.color(scontrol) 1 $calc($1 + 3) %gui.y $calc($3 - 22) $calc(%gui.height - 1)
      var %gui.dline = $calc($3 - 24) $calc(%gui.height - 3)
      drawrect -frn $+(@GUI.,%gui.name) $gui.color(fcontrol) 1 $calc($1 + 4) $calc(%gui.y + 1) %gui.dline
    }

    var %gui.compteur2 = 1, %gui.x = $1 + 6
    while ($gettok(%gui.item,%gui.compteur2,8)) {

      var %gui.text = $v1
      var %gui.width = $gettok($gui.getInfo(%gui.name,%gui.id).colonne,$calc(%gui.compteur2 * 2),8)

      ;Wrap text that are longer than the list width
      if ($width(%gui.text,Verdana,11) > $calc(%gui.width - 22)) {
        %gui.text = $+($wrap(%gui.text,Verdana,11,$calc(%gui.width - 22),0,1),...)
      }

      drawtext -rn $+(@GUI.,%gui.name) $gui.color(text) Verdana 11 %gui.x %gui.y %gui.text
      inc %gui.x %gui.width
      inc %gui.compteur2
    }

    inc %gui.nbitem
    inc %gui.y %gui.height
    inc %gui.compteur

  }

  drawdot $+(@GUI.,%gui.name)

  gui.drawScrollThumb %gui.name %gui.id

}

alias gui.ilview {

  tokenize 9 $gui.getData2($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.ilview: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) ilview
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5

    if (!$gui.getInfo($gui.short(%gui.window),$1).hide) {
      drawrect -rn %gui.window $gui.color(border) 1 $2-5
      drawrect -rn %gui.window $gui.color(shadow) 1 $calc($2 + 1) $calc($3 + 1) $calc($4 - 2) $calc($5 - 2)

      drawrect -frn %gui.window $gui.color(hilight) 1 $calc($2 + 2) $calc($3 + 2) $calc($4 - 4) $calc($5 - 4)

      drawdot %gui.window
    }

  }

}

alias gui.drawIlview {

  var %gui.window = $+(@GUI.,$1)
  var %gui.name = $1, %gui.id = $2

  tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

  drawrect -frn %gui.window $gui.color(hilight) 1 $calc($1 + 2) $calc($2 + 2) $calc($3 - 4) $calc($4 - 4)

  hadd gui $+(%gui.name,.,%gui.id,.lines) 1

  var %gui.compteur = 1, %gui.dx = 45, %gui.dy = 15, %gui.x = %gui.dx + $1, %gui.y = %gui.dy + $2
  while ($hget(gui,$+(%gui.name,.,%gui.id,.ilvitem.,%gui.compteur))) {
    var %gui.text = $gettok($v1,1,8), %gui.icon = $gettok($v1,2,8), %gui.tWidth = $width(%gui.text,Verdana,11)

    drawpic -smn %gui.window %gui.x %gui.y 32 32 %gui.icon

    if (%gui.tWidth > 100) {
      %gui.text = $+($wrap(%gui.text,Verdana,11,100,0,1),...)
      %gui.tWidth = $width(%gui.text,Verdana,11)
    }

    var %gui.tx = $calc(%gui.x - (%gui.tWidth / 2) + 15)

    drawrect -frn %gui.window $gui.color(fcontrol) 1 $calc(%gui.tx - 3) $calc(%gui.y + 34) $calc(%gui.tWidth + 6) 15
    drawrect -rn %gui.window $gui.color(border) 1 $calc(%gui.tx - 3) $calc(%gui.y + 34) $calc(%gui.tWidth + 6) 15

    drawtext -rn %gui.window $gui.color(text) Verdana 11 %gui.tx $calc(%gui.y + 34) %gui.text

    inc %gui.x $calc(%gui.dx + 50)

    if ($calc($3 - %gui.x) < 65) { 
      hadd gui $+(%gui.name,.,%gui.id,.rows) $floor($calc((%gui.x - %gui.dx - 20) / (%gui.dx + 35)))
      hinc gui $+(%gui.name,.,%gui.id,.lines)
      %gui.x = %gui.dx + $1 | inc %gui.y $calc(%gui.dy + 50) 
    }

    inc %gui.compteur
  }

  drawdot %gui.window

}

alias -l gui.drawSelectedIlview {

  var %gui.x = $5
  var %gui.y = $6

  var %gui.name = $3
  var %gui.id = $4
  var %gui.window = $+(@GUI.,%gui.name)

  var %gui.rows = $hget(gui,$+(%gui.name,.,%gui.id,.rows))
  var %gui.sclick = $calc(%gui.x + (%gui.y - 1) * %gui.rows)

  if (%gui.x <= %gui.rows) && (%gui.y <= $hget(gui,$+(%gui.name,.,%gui.id,.lines))) && (%gui.x) && (%gui.y) {
    if ($hget(gui,$+(%gui.name,.,%gui.id,.ilvitem.,%gui.sclick))) {
      var %gui.text = $gettok($v1,1,8), %gui.icon = $gettok($v1,2,8), %gui.tWidth = $width(%gui.text,Verdana,11)

      hadd gui $+(%gui.name,.,%gui.id,.sX) %gui.x
      hadd gui $+(%gui.name,.,%gui.id,.sY) %gui.y

      var %gui.dx = 45, %gui.dy = 15
      var %gui.x = $calc((%gui.dx + $1) + ((%gui.dx + 50) * (%gui.x - 1)))
      var %gui.y = $calc((%gui.dy + $2) + ((%gui.dy + 50) * (%gui.y - 1)))

      drawpic -smn %gui.window %gui.x %gui.y 32 32 %gui.icon

      hadd gui $+(%gui.name,.focus) %gui.id

      if (%gui.tWidth > 100) {
        %gui.text = $+($wrap(%gui.text,Verdana,11,100,0,1),...)
        %gui.tWidth = $width(%gui.text,Verdana,11)
      }

      var %gui.tx = $calc(%gui.x - (%gui.tWidth / 2) + 15)

      var %gui.dline = 1 $calc(%gui.tx - 3) $calc(%gui.y + 34) $calc(%gui.tWidth + 6) 15

      drawrect -frn %gui.window $gui.color(scontrol) %gui.dline
      drawrect -rn %gui.window $gui.color(border) %gui.dline

      drawtext -rn %gui.window $gui.color(textshadow) Verdana 11 %gui.tx $calc(%gui.y + 34) %gui.text

      drawdot %gui.window
    }
  }
}

alias gui.tview {

  tokenize 9 $gui.getData2($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.tview: id already exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) tview
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.sposition) 1

    drawrect -rn %gui.window $gui.color(border) 1 $2-5
    drawrect -rn %gui.window $gui.color(shadow) 1 $calc($2 + 1) $calc($3 + 1) $calc($4 - 2) $calc($5 - 2)

    drawrect -frn %gui.window $gui.color(hilight) 1 $calc($2 + 2) $calc($3 + 2) $calc($4 - 4) $calc($5 - 4)

    gui.drawScroll %gui.window $1 $calc($2 + $4 - 17) $calc($3 + 3) 14 $calc($5 - 6)

    if (!$hget(gui,$+($gui.short(%gui.window),.stopDraw))) drawdot %gui.window

  }

}

alias gui.drawTreeView {

  var %gui.name = $1, %gui.id = $2
  tokenize 32 $gui.getInfo($1,$2).position

  var %gui.compteur = $gui.getInfo(%gui.name,%gui.id).sposition, %gui.x = $1 + 6, %gui.y = $2 + 5
  var %gui.height = $calc($height(a,Verdana,11) + 2)
  var %gui.maxitem = $calc(($4 - 10) / %gui.height), %gui.nbitem = 1
  var %gui.window = $+(@GUI.,%gui.name)
  var %gui.sel = $gui.getInfo(%gui.name,%gui.id).sel

  ;Ajusting %gui.x with the position of the scrollbar
  var %gui.compteur2 = 1 
  while (%gui.compteur2 < %gui.compteur) {
    var %gui.data1 = $gettok($hget(gui,$+(%gui.name,.,%gui.id,.tvitem.,%gui.compteur2)),1,32)
    if (%gui.data1 == 1) inc %gui.x 20
    elseif (%gui.data1 == -1) dec %gui.x 20
    inc %gui.compteur2
  }

  drawrect -frn %gui.window $gui.color(hilight) 1 $calc($1 + 2) $calc($2 + 3) $calc($3 - 20) $calc($4 - 5)

  while (%gui.nbitem <= %gui.maxitem) && ($hget(gui,$+(%gui.name,.,%gui.id,.tvitem.,%gui.compteur))) {
    var %gui.item = $v1, %gui.data1 = $gettok(%gui.item,1,32), %gui.data2 = $gettok(%gui.item,2-,32)

    if (%gui.data1 == 1) inc %gui.x 20
    elseif (%gui.data1 == -1) dec %gui.x 20

    if (%gui.x < $1) { echo -s * /gdid: you can't create a branch outside of the treeview! | halt }

    if (%gui.compteur == %gui.sel) {

      var %gui.dline = $calc($3 - (%gui.x - $1 - 18) - 35), %gui.dline2 = $calc(%gui.height - 1)
      drawrect -rn %gui.window $gui.color(scontrol) 1 $calc(%gui.x - 2) $calc(%gui.y - 2) %gui.dline %gui.dline2

      var %gui.dline3 = $calc(%gui.dline - 2) $calc(%gui.dline2 - 2)
      drawrect -frn %gui.window $gui.color(fcontrol) 1 $calc(%gui.x - 1) $calc(%gui.y - 1) %gui.dline3

      var %gui.dline = 1 $calc(%gui.x + 1) $calc(%gui.y + 1)
      drawrect -rn %gui.window $gui.color(border) 1 %gui.x %gui.y 10 10
      drawrect -frn %gui.window $gui.color(bg) %gui.dline 8 8
      drawrect -rn %gui.window $gui.color(shadow) %gui.dline 8 8
      drawline -rn %gui.window $gui.color(hilight) %gui.dline $calc(%gui.x + 1) $calc(%gui.y + 9)
      drawline -rn %gui.window $gui.color(hilight) %gui.dline $calc(%gui.x + 9) $calc(%gui.y + 1)

      var %gui.text = $gettok($hget(gui,$+(%gui.name,.,%gui.id,.tvitem.,%gui.sel)),2-,32) 

      var %gui.offset = $calc(%gui.x - $1 - 18)

      if ($calc($width(%gui.text,Verdana,11) + %gui.offset) > $calc($3 - 52)) {
        %gui.text = $+($wrap(%gui.text,Verdana,11,$calc($3 - 65 - %gui.offset),0,1),...)
      }

      drawtext -rn %gui.window $gui.color(textshadow) Verdana 11 $calc(%gui.x + 15) $calc(%gui.y - 1) %gui.text
      drawtext -rn %gui.window $gui.color(text) Verdana 11 $calc(%gui.x + 14) $calc(%gui.y - 2) %gui.text  

    }
    else {

      var %gui.dline = $calc(%gui.x + 1) $calc(%gui.y + 1)
      drawrect -rn %gui.window $gui.color(border) 1 %gui.x %gui.y 10 10
      drawrect -frn %gui.window $gui.color(fcontrol) 1 %gui.dline 8 8
      drawrect -rn %gui.window $gui.color(scontrol) 1 %gui.dline 8 8
      drawline -rn %gui.window $gui.color(hcontrol) 1 %gui.dline $calc(%gui.x + 9) $calc(%gui.y + 1)
      drawline -rn %gui.window $gui.color(hcontrol) 1 %gui.dline $calc(%gui.x + 1) $calc(%gui.y + 9)

      var %gui.offset = $calc(%gui.x - $1 - 6)

      if ($calc($width(%gui.data2,Verdana,11) + %gui.offset) > $calc($3 - 52)) {
        %gui.data2 = $+($wrap(%gui.data2,Verdana,11,$calc($3 - 52 - %gui.offset),0,1),...)
      }

      drawtext -rn %gui.window $gui.color(text) Verdana 11 $calc(%gui.x + 14) $calc(%gui.y - 2) %gui.data2
    }

    inc %gui.nbitem
    inc %gui.y %gui.height
    inc %gui.compteur

  }

  gui.drawScrollThumb %gui.name %gui.id

  if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot %gui.window

}

alias gui.img {

  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.img: id already exists
  elseif (!$isfile($6-)) echo -s * /gui.img: $+(",$6-,") doesn't exists
  else {

    hadd gui $+($gui.short(%gui.window),.,$1,.type) img
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.img) $6-

    drawpic -smtn %gui.window $rgb(255,0,255) $2-

    if (!$hget(gui,$+($gui.short(%gui.window),.stopDraw))) drawdot %gui.window

  }

}

alias gui.mbar {

  var %gui.id = $gettok($1-,2,44), %gui.items = $gettok($1-,1,34)
  var %gui.x = $calc($gettok($gettok($1-,3-,44),1,32) + 2), %gui.y = $calc($gettok($gettok($1-,3-,44),2,32) + 24)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),%gui.id)) echo -s * /gui.mbar: id already exists
  else {
    hadd gui $+($gui.short(%gui.window),.,%gui.id,.type) mbar
    hadd gui $+($gui.short(%gui.window),.,%gui.id,.position) %gui.x %gui.y
    hadd gui $+($gui.short(%gui.window),.,%gui.id,.items) %gui.items

    gui.drawMbar %gui.window %gui.id %gui.x %gui.y %gui.items

  }

}

alias gui.drawMbar {

  var %gui.x = $3, %gui.y = $4, %gui.compteur = 1, %gui.ox = %gui.x
  while ($gettok($5,%gui.compteur,8)) {
    var %gui.text = $v1
    drawtext -rn $1 $gui.color(text) Verdana 11 %gui.x %gui.y %gui.text
    inc %gui.x $calc($width(%gui.text,Verdana,11) + 10)
    inc %gui.compteur 2
  }

  var %gui.xy = $gettok($gui.getInfo($gui.short($1),$2).position,1-2,32)
  hadd gui $+($gui.short($1),.,$2,.width) $calc(%gui.x - %gui.ox)
  hadd gui $+($gui.short($1),.,$2,.position) %gui.xy $calc(%gui.x - %gui.ox) 20
}

alias gui.tbButton {
  tokenize 9 $gui.getData($1-)

  var %gui.window = $hget(gui,lastcreated)

  if ($gui.checkId($gui.short(%gui.window),$1)) echo -s * /gui.tbButton: id already exists
  else {
    hadd gui $+($gui.short(%gui.window),.,$1,.type) tbButton
    hadd gui $+($gui.short(%gui.window),.,$1,.position) $2-5
    hadd gui $+($gui.short(%gui.window),.,$1,.icon) $6-

    gui.drawTbButton 1 %gui.window $1-
  }
}
alias gui.drawTbButton {
  if ($1 == 1) var %gui.color1 = $gui.color(hilight), %gui.color2 = $gui.color(shadow) 
  else var %gui.color1 = $gui.color(shadow), %gui.color2 = $gui.color(hilight) 

  var %gui.width = $calc($4 + 1), %gui.height = $calc($5 + 1)

  drawrect -rn $2 $gui.color(border) 1 $4-7
  drawline -rn $2 %gui.color1 1 %gui.width %gui.height $calc(%gui.width + $6 - 3) %gui.height
  drawline -rn $2 %gui.color1 1 %gui.width %gui.height %gui.width $calc(%gui.height + $7 - 3)
  var %gui.drawline = $calc(%gui.height + $7 - 3) $calc(%gui.width + $6 - 3) %gui.height
  drawline -rn $2 %gui.color2 1 %gui.width $calc(%gui.height + $7 - 3) $calc(%gui.width + $6 - 3) %gui.drawline
  drawrect -frn $2 $gui.color(bg) 1 $calc(%gui.width + 1) $calc(%gui.height + 1) $calc($6 - 4) $calc($7 - 4)

  var %gui.x = 5, %gui.y = 5

  if ($1 == 2) { inc %gui.x | inc %gui.y }

  drawpic -mfsnt $2 $rgb(255,0,255) $calc($4 + %gui.x) $calc($5 + %gui.y) 16 16 $8-

  if (!$hget(gui,$+($gui.short($2),.stopDraw))) drawdot $2
}

alias -l gui.move {
  .signal -n $+(GUI.,$gui.short($mouse.win)) MOVE
  if ($window($3)) window $3 $calc($mouse.dx - $1) $calc($mouse.dy - $2)
  if ($mouse.key & 1) $+(.timer,$ticks) -m 1 0 gui.move $1-
}

/*
 /gui.setInfo name id property value
 Set the property of an ID in a GUI window
*/
alias gui.setInfo hadd gui $+($1,.,$2,.,$3) $4-

/*
 $gui.getInfo(name,id).property
 Return the property of an ID in a GUI window
*/
alias gui.getInfo return $hget(gui,$+($1,.,$2,.,$prop))
alias -l gui.checkId { if ($hget(gui,$+($1,.,$2,.type))) return 1 }

alias -l gui.getData {
  if ("" isin $gettok($1-,1,44)) var %gui.num = 1 | else var %gui.num = 2
  var %gui.id = $gettok($gettok($1-,%gui.num,34),1,44)
  if (%gui.num == 2) var %gui.text = $gettok($1-,1,34)
  var %gui.position = $gettok($gettok($1-,%gui.num,34),2,44)

  var %gui.x = $calc($gettok(%gui.position,1,32) + 2)
  var %gui.y = $calc($gettok(%gui.position,2,32) + 24)
  var %gui.w = $gettok(%gui.position,3,32)
  var %gui.h = $gettok(%gui.position,4,32)

  return $+(%gui.id,$chr(9),%gui.x,$chr(9),%gui.y,$chr(9),%gui.w,$chr(9),%gui.h,$chr(9),%gui.text)
}

alias -l gui.getData2 {

  var %gui.id = $gettok($1-,1,44)
  var %gui.position = $gettok($1-,2,44)

  var %gui.x = $calc($gettok(%gui.position,1,32) + 2)
  var %gui.y = $calc($gettok(%gui.position,2,32) + 24)
  var %gui.w = $gettok(%gui.position,3,32)
  var %gui.h = $gettok(%gui.position,4,32)

  return $+(%gui.id,$chr(9),%gui.x,$chr(9),%gui.y,$chr(9),%gui.w,$chr(9),%gui.h)
}

alias -l gui.getData3 {
  var %gui.id = $gettok($gettok($1-,2,34),1,44), %gui.text = $gettok($1-,1,34)
  var %gui.position = $gettok($gettok($1-,2,34),2,44)

  var %gui.x = $calc($gettok(%gui.position,1,32) + 2)
  var %gui.y = $calc($gettok(%gui.position,2,32) + 24)
  var %gui.w = $gettok(%gui.position,3,32)
  var %gui.h = $gettok(%gui.position,4,32)

  var %gui.group = $gettok($gettok($1-,2,34),3,44)

  return $+(%gui.id,$chr(9),%gui.x,$chr(9),%gui.y,$chr(9),%gui.w,$chr(9),%gui.h,$chr(9),%gui.text,$chr(9),%gui.group)
}

alias -l gui.getData4 {
  var %gui.id = $gettok($gettok($1-,1,34),1,44)
  var %gui.position = $gettok($gettok($1-,1,34),2,44)

  var %gui.img $gettok($1-,3,44)

  var %gui.x = $calc($gettok(%gui.position,1,32) + 2)
  var %gui.y = $calc($gettok(%gui.position,2,32) + 24)
  var %gui.w = $gettok(%gui.position,3,32)
  var %gui.h = $gettok(%gui.position,4,32)

  return $+(%gui.id,$chr(9),%gui.x,$chr(9),%gui.y,$chr(9),%gui.w,$chr(9),%gui.h,$chr(9),%gui.img)
}

alias gui.exists { if ($window($+(@GUI.,$1))) return 1 }
alias gui.close { 
  .signal -n $+(GUI.,$1) close | window -c $+(@GUI.,$1)
  var %gui.combo = 1 | while ($window($+(@Combo.,$1,.*),%gui.combo)) { window -c $v1 | inc %gui.combo }
  hdel -w gui $+($1,.*) | $+(.timerGUI,$1) off
}
on *:close:@GUI.*:gui.close $gui.short($target)
alias gui.short return $gettok($1-,2-,46)

/*
alias drawdot { if (!$hget(gui,$+($gui.short($1),.stopUpdate))) && (!$2) drawdot $1 }

alias gui.beginUpdate hadd gui $+($1,.stopUpdate) 1
alias gui.endUpdate { hdel gui $+($1,.stopUpdate) | drawdot $+(@GUI.,$1) }
*/

alias gdid {

  if ($isid) {

    var %gui.type = $gui.getInfo($1,$2).type

    if ($prop == text) {
      if (%gui.type == text) || (%gui.type == edit) || (%gui.type == button) {
        ;        return $replace($gui.getInfo($1,$2).text,$chr(160),$chr(32))
        return $gui.getInfo($1,$2).text

      }
    }
    if ($prop == selText) {
      if (%gui.type == edit) {
        return $gui.getInfo($1,$2).selText
      }
    }

    if ($prop == state) {
      if (%gui.type == radio) || (%gui.type == check) return $iif($gui.getInfo($1,$2).state,$v1,0)
    }

    if ($prop == sel) {
      if (%gui.type == list) || (%gui.type == lview) || (%gui.type == tview) || (%gui.type == combo) {
        return $gui.getInfo($1,$2).sel
      }
    }

    if ($prop == lines) {
      if (%gui.type == list) || (%gui.type == lview) || (%gui.type == tview) return $hget(gui,$+($1,.,$2,.nbItem))
      if (%gui.type == combo) return $hfind(gui,$+($1,.,$2,.citem.*),0,w)
    }

    if ($prop == seltext) {
      var %gui.sel = $gui.getInfo($1,$2).sel
      if (%gui.type == list) return $hget(gui,$+($1,.,$2,.litem.,%gui.sel))
      if (%gui.type == lview) return $hget(gui,$+($1,.,$2,.lvitem.,%gui.sel))
      if (%gui.type == tview) return $gettok($hget(gui,$+($1,.,$2,.tvitem.,%gui.sel)),2-,32)
      if (%gui.type == combo) return $hget(gui,$+($1,.,$2,.citem.,%gui.sel))
    }

    if ($3) {
      if (%gui.type == list) return $hget(gui,$+($1,.,$2,.litem.,$3))
      if (%gui.type == lview) return $hget(gui,$+($1,.,$2,.lvitem.,$3))
      if (%gui.type == combo) return $hget(gui,$+($1,.,$2,.citem.,$3))
    }

  }
  else {

    var %gui.type = $gui.getInfo($2,$3).type
    var %gui.name = $2, %gui.id = $3, %gui.data = $4-
    var %gui.param = $1, %gui.window = $+(@GUI.,$2)

    tokenize 32 $gui.getInfo($2,$3).position

    if (r isin %gui.param) {
      if (%gui.type == text) || (%gui.type == edit) || (%gui.type == box) || (%gui.type == button) {
        hdel gui $+(%gui.name,.,%gui.id,.text)
      }
    }

    if (r isin %gui.param) && (%gui.type == combo) {
      hdel -w gui $+(%gui.name,.,%gui.id,.citem.*)
    }

    if (r isin %gui.param) && (%gui.type == list) {
      hadd gui $+(%gui.name,.,%gui.id,.sposition) 1
      gui.drawScroll %gui.window %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)
      hdel -w gui $+(%gui.name,.,%gui.id,.litem.*)
      hadd gui $+(%gui.name,.,%gui.id,.nbItem) 0
    }


    if (r isin %gui.param) && (%gui.type == lview) {
      hadd gui $+(%gui.name,.,%gui.id,.sposition) 1
      gui.drawScroll %gui.window %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)
      hdel -w gui $+(%gui.name,.,%gui.id,.lvitem.*)
      hadd gui $+(%gui.name,.,%gui.id,.nbItem) 0
    }

    if (a isin %gui.param) && (%gui.data) {
      if (%gui.type == text) {
        var %gui.text = $+($gui.getInfo(%gui.name,%gui.id).text,%gui.data)
        hadd gui $+(%gui.name,.,%gui.id,.text) %gui.text
        gui.drawText $+(@GUI.,%gui.name) $1-4 %gui.text
      }
      if (%gui.type == button) {
        var %gui.text = $+($gui.getInfo(%gui.name,%gui.id).text,%gui.data)
        hadd gui $+(%gui.name,.,%gui.id,.text) %gui.text
        gui.drawButton 1 $+(@GUI.,%gui.name) %gui.id $1-4 $gui.getInfo(%gui.name,%gui.id).text
      }
      if (%gui.type == edit) {
        var %gui.text = $+($gui.getInfo(%gui.name,%gui.id).text,%gui.data)
        hadd gui $+(%gui.name,.,%gui.id,.text) %gui.text

        var %gui.iFocus = $hget(gui,$+(%gui.name,.focus))

        gui.changeFocus 1 %gui.name %gui.id
        gui.edit.drawText 0 1 %gui.window
        gui.changeFocus 1 %gui.name %gui.iFocus
      }
      if (%gui.type == combo) {
        var %gui.nitem = $calc($hfind(gui,$+(%gui.name,.,%gui.id,.citem.*),0,w) + 1)
        hadd gui $+(%gui.name,.,%gui.id,.citem.,%gui.nitem) %gui.data
      }
      if (%gui.type == list) {
        hinc gui $+(%gui.name,.,%gui.id,.nbItem)
        hadd gui $+(%gui.name,.,%gui.id,.litem.,$hget(gui,$+(%gui.name,.,%gui.id,.nbItem))) %gui.data
        if (n !isin %gui.param) {
          gui.drawList %gui.name %gui.id
          gui.drawScrollThumb %gui.name %gui.id
        }
      }
      if (%gui.type == ilview) {
        hinc gui $+(%gui.name,.,%gui.id,.nbItem)
        hadd gui $+(%gui.name,.,%gui.id,.ilvitem.,$hget(gui,$+(%gui.name,.,%gui.id,.nbItem))) %gui.data
        if (n !isin %gui.param) gui.drawIlview %gui.name %gui.id
      }
      if (%gui.type == lview) {
        hinc gui $+(%gui.name,.,%gui.id,.nbItem)
        hadd gui $+(%gui.name,.,%gui.id,.lvitem.,$hget(gui,$+(%gui.name,.,%gui.id,.nbItem))) %gui.data
        if (n !isin %gui.param) {
          gui.drawListView %gui.name %gui.id
          gui.drawScrollThumb %gui.name %gui.id
        }
      }
      if (%gui.type == tview) {
        hinc gui $+(%gui.name,.,%gui.id,.nbItem)
        hadd gui $+(%gui.name,.,%gui.id,.tvitem.,$hget(gui,$+(%gui.name,.,%gui.id,.nbItem))) %gui.data
        if (n !isin %gui.param) {
          gui.drawTreeView %gui.name %gui.id
          gui.drawScrollThumb %gui.name %gui.id
        }
      }
      if (%gui.type == box) {
        var %gui.text = $+($gui.getInfo(%gui.name,%gui.id).text,%gui.data)
        hadd gui $+(%gui.name,.,%gui.id,.text) %gui.text
        gui.drawBox $+(@GUI.,%gui.name) $1-4 %gui.text
      }

    }

    if (%gui.param == -t) && (%gui.data) hadd gui $+(%gui.name,.,%gui.id,.tooltips) %gui.data

    if (h isin %gui.param) {
      hadd gui $+(%gui.name,.,%gui.id,.hide) 1
      if (n isin %gui.param) var %gui.opt = -frn
      else var %gui.opt -fr 
      if ($1) drawrect %gui.opt $+(@GUI.,%gui.name) $gui.color(bg) 1 $1-2 $calc($3 + 1) $calc($4 + 3)
    }

    if (%gui.param == -v) {
      hdel gui $+(%gui.name,.,%gui.id,.hide)

      if (%gui.type == text) gui.drawText %gui.window $1-4 $gui.getInfo(%gui.name,%gui.id).text
      if (%gui.type == button) gui.drawButton 1 %gui.window %gui.id $1-4 $gui.getInfo(%gui.name,%gui.id).text
      if (%gui.type == edit) {
        var %gui.text = $gui.getInfo(%gui.name,%gui.id).text

        gui.drawListBorder %gui.window $1-4
        gui.changeFocus 1 %gui.name %gui.id
        gui.edit.drawText 0 1 %gui.window
      }     
      if (%gui.type == box) gui.drawBox %gui.window $1-4 $gui.getInfo(%gui.name,%gui.id).text
      if (%gui.type == combo) {
        gui.drawCombo %gui.window $1-4 
        if ($gui.getInfo(%gui.name,%gui.id).sel) gui.drawComboSelect %gui.name %gui.id $v1 
      }
      if (%gui.type == list) {
        gui.drawListBorder %gui.window $1-4
        gui.drawList %gui.name %gui.id
        gui.drawScroll %gui.window %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)
        gui.drawScrollThumb %gui.name %gui.id
      }
      if (%gui.type == lview) {
        gui.drawListBorder %gui.window $1-4
        gui.drawLviewHeaders %gui.window $1-4 $gui.getInfo(%gui.name,%gui.id).colonne
        gui.drawListView %gui.name %gui.id
        gui.drawScroll %gui.window %gui.id $calc($1 + $3 - 17) $calc($2 + 3) 14 $calc($4 - 6)
        gui.drawScrollThumb %gui.name %gui.id
      }
      if (%gui.type == check) {
        gui.drawSquare %gui.window $1-2
        if ($gui.getInfo(%gui.name,%gui.id).state) {
          drawtext -rn %gui.window $gui.color(text) Webdings 10 $calc($1 + 2) $calc($2 - 3) r
        }
        gui.drawText %gui.window $calc($1 + 15) $calc($2 - 6) $calc($3 - 12) $4 $gui.getInfo(%gui.name,%gui.id).text
      }
      if (%gui.type == radio) {
        gui.drawRadio %gui.window $1-2
        if ($gui.getInfo(%gui.name,%gui.id).state) {
          drawrect -fern %gui.window $gui.color(text) 1 $calc($1 + 3) $calc($2 + 3) 5 5
        }
        gui.drawText %gui.window $calc($1 + 15) $calc($2 - 6) $calc($3 - 12) $4 $gui.getInfo(%gui.name,%gui.id).text
      }
    }

    if (%gui.param == -i) {
      if (%gui.type == list) {
        hadd gui $+(%gui.name,.,%gui.id,.litem.,$gettok(%gui.data,1,32)) $gettok(%gui.data,2-,32)
        gui.drawList %gui.name %gui.id
      }
      if (%gui.type == lview) {
        hadd gui $+(%gui.name,.,%gui.id,.lvitem.,$gettok(%gui.data,1,32)) $gettok(%gui.data,2-,32)
        gui.drawListView %gui.name %gui.id
      }
    }

    if (%gui.param == -d) {
      if (%gui.type == list) {
        var %gui.item = $+(%gui.name,.,%gui.id,.litem.)

        if ($gui.getInfo(%gui.name,%gui.id).sel == %gui.data) hdel gui $+(%gui.name,.,%gui.id,.sel)

        while ($hget(gui,$+(%gui.name,.,%gui.id,.litem.,%gui.data))) {
          hadd gui $+(%gui.item,%gui.data) $hget(gui,$+(%gui.item,$calc(%gui.data + 1)))
          inc %gui.data
        }
        hdel gui $+(%gui.item,$calc(%gui.data - 1))

        hdec gui $+(%gui.name,.,%gui.id,.nbItem)

        gui.drawList %gui.name %gui.id
      }
      if (%gui.type == lview) {

        var %gui.item = $+(%gui.name,.,%gui.id,.lvitem.)

        if ($gui.getInfo(%gui.name,%gui.id).sel == %gui.data) hdel gui $+(%gui.name,.,%gui.id,.sel)

        while ($hget(gui,$+(%gui.name,.,%gui.id,.lvitem.,%gui.data))) {
          hadd gui $+(%gui.item,%gui.data) $hget(gui,$+(%gui.item,$calc(%gui.data + 1)))
          inc %gui.data
        }
        hdel gui $+(%gui.item,$calc(%gui.data - 1))

        hdec gui $+(%gui.name,.,%gui.id,.nbItem)

        gui.drawListView %gui.name %gui.id
      }
      if (%gui.type == combo) {
        var %gui.item = $+(%gui.name,.,%gui.id,.citem.), %gui.sel = %gui.data

        if ($gui.getInfo(%gui.name,%gui.id).sel == %gui.data) hdel gui $+(%gui.name,.,%gui.id,.sel)

        while ($hget(gui,$+(%gui.name,.,%gui.id,.citem.,%gui.data))) {
          hadd gui $+(%gui.item,%gui.data) $hget(gui,$+(%gui.item,$calc(%gui.data + 1)))
          inc %gui.data
        }
        hdel gui $+(%gui.item,$calc(%gui.data - 1))

        if (%gui.sel == 1) && ($hget(gui,$+(%gui.name,.,%gui.id,.citem.1))) {
          hadd gui $+(%gui.name,.,%gui.id,.over) 1
          gui.drawComboSelect %gui.name %gui.id 1
        }
        else {
          hadd gui $+(%gui.name,.,%gui.id,.over) $calc(%gui.sel - 1)
          gui.drawComboSelect %gui.name %gui.id $calc(%gui.sel - 1)
        }

      }
    }

    if (%gui.param == -f) {
      if (%gui.type == button) {
        hadd gui $+(%gui.name,.,%gui.id,.font) $gettok(%gui.data,2-,32)
        hadd gui $+(%gui.name,.,%gui.id,.fontSize) $gettok(%gui.data,1,32)

        gui.drawButton 1 $+(@GUI.,%gui.name) %gui.id $1- $gui.getInfo(%gui.name,%gui.id).text
      }
    }

    if (%gui.param == -c) {

      if (%gui.type == tbar) {
        hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.data
        gui.drawTbar $+(@GUI.,%gui.name) $1-4 %gui.data
      }

      if (%gui.type == list) {
        if ($hget(gui,$+(%gui.name,.,%gui.id,.nbItem)) >= %gui.data) {
          hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.data
          gui.drawList %gui.name %gui.id
          .signal -n $+(GUI.,%gui.name) SCLICK %gui.id
        }
        else echo -s * /gdid: selected line number can be bigger than the total of lines
      }

      if (%gui.type == lview) {
        if ($hget(gui,$+(%gui.name,.,%gui.id,.nbItem)) >= %gui.data) {
          hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.data
          .signal -n $+(GUI.,%gui.name) SCLICK %gui.id
          gui.drawListView %gui.name %gui.id
        }
        else echo -s * /gdid: selected line number can be bigger than the total of lines
      }

      if (%gui.type == check) {

        drawrect -frn %gui.window $gui.color(fcontrol) 1 $calc($1 + 2) $calc($2 + 2) 8 8

        if ($gui.getInfo(%gui.name,%gui.id).state != 1) {
          drawtext -rn %gui.window $gui.color(text) Webdings 10 $calc($1 + 2) $calc($2 - 3) r
          hadd gui $+(%gui.name,.,%gui.id,.state) 1
        }
        else hadd gui $+(%gui.name,.,%gui.id,.state) 0

        if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot %gui.window
      }

      if (%gui.type == combo) {
        gui.drawComboSelect %gui.name %gui.id %gui.data
      }

      if (%gui.type == radio) {

        var %gui.compteur = 1, %gui.group = $gui.getInfo(%gui.name,%gui.id).group
        var %gui.total = $hfind(gui,$+(%gui.name,.*.group),0,w)

        while (%gui.compteur <= %gui.total) {
          if ($hget(gui,$hfind(gui,$+(%gui.name,.*.group),%gui.compteur,w)) == %gui.group) {
            var %gui.control = $hfind(gui,$+(%gui.name,.*.group),%gui.compteur,w)
            var %gui.oid = $gettok(%gui.control,2,46)
            var %gui.position = $gui.getInfo(%gui.name,%gui.oid).position

            var %gui.xy = $calc($gettok(%gui.position,1,32) + 3) $calc($gettok(%gui.position,2,32) + 3)

            drawrect -fern %gui.window $gui.color(fcontrol) 1 %gui.xy 5 5
            hadd gui $+(%gui.name,.,%gui.oid,.state) 0
          }
          inc %gui.compteur
        }

        drawrect -fern %gui.window $gui.color(text) 1 $calc($1 + 3) $calc($2 + 3) 5 5
        hadd gui $+(%gui.name,.,%gui.id,.state) 1

        if (!$hget(gui,$+(%gui.name,.stopDraw))) drawdot %gui.window

      }

    }

    if (%gui.type == pbar) {
      if (%gui.data > 100) || (%gui.data < 0) { echo -s * /gdid: progress value must be between 0 and 100 | return }
      gui.ajustPbar %gui.name %gui.id %gui.data
    }

    if (%gui.type == tview) {
      hadd gui $+(%gui.name,.,%gui.id,.sel) %gui.data
      gui.drawTreeView %gui.name %gui.id  
    }

  }

}

alias gui.scrollToCaret {
  var %gui.name = $1, %gui.id = $2

  tokenize 32 $gui.getInfo(%gui.name,%gui.id).position

  var %gui.nbItems = $floor($calc(($4 - 10) / ($height(a,Verdana,11) + 2)))
  var %gui.sel = $calc($gdid(%gui.name,%gui.id).lines - %gui.nbItems) + 1

  if (%gui.sel > 0) {
    hadd gui $+(%gui.name,.,%gui.id,.sposition) %gui.sel
    gui.drawList %gui.name %gui.id
  }
}

/*
 Popups engine for Alse
*/

alias popups.add {

  hadd popups $+($1,.,$calc($hfind(popups,$+($1,.*),0,w) + 1)) $2-

  if ($left($2,1) == +) { 
    var %pop.parent = $1 | tokenize 58 $2-
    hadd popups $+($2,.parent) %pop.parent 
  }
}

alias popups.draw {
  var %pop.win = $+(@Popups.,$1)
  var %pop.width = 1, %pop.height = 9

  var %pop.compteur = 1
  while ($hget(popups,$+($1,.,%pop.compteur))) {
    var %pop.line = $v1
    if (%pop.width < $width($gettok(%pop.line,1,58),Verdana,11)) %pop.width = $v2

    if (%pop.line == -) inc %pop.height 4
    else inc %pop.height 18

    inc %pop.compteur
  }
  inc %pop.width 50

  window -pdokB +dL %pop.win $iif($2-3,$2-3,$mouse.dx $mouse.dy) %pop.width %pop.height

  drawrect -frn %pop.win $gui.color(bg) 1 0 0 %pop.width %pop.height
  drawrect -rn %pop.win $gui.color(border) 1 0 0 %pop.width %pop.height
  drawrect -rn %pop.win $gui.color(shadow) 1 1 1 $calc(%pop.width - 2) $calc(%pop.height - 2)
  drawline -rn %pop.win $gui.color(hilight) 1 1 1 $calc(%pop.width - 2) 1

  popups.drawContents $1

}

alias popups.drawContents {

  var %pop.win = $+(@Popups.,$1)
  var %pop.width = $window(%pop.win).w
  var %pop.compteur = 1, %pop.y = 6

  drawrect -frn %pop.win $gui.color(bg) 1 3 3 $calc(%pop.width - 6) $calc($window(%pop.win).h - 6)

  var %pop.submenus = $+($gettok($mouse.win,2-,46),.submenus)
  hdel popups %pop.submenus

  ;Left bar
  drawrect -frn %pop.win $gui.color(fcontrol) 1 2 2 20 $calc($window(%pop.win).h - 4)
  drawline -rn %pop.win $gui.color(border) 1 22 1 22 $window(%pop.win).h

  ;Edge of the left bar
  if ($hget(config,popups.3d)) {
    drawrect -rn %pop.win $gui.color(scontrol) 1 1 1 21 $calc($window(%pop.win).h - 2)
    drawline -rn %pop.win $gui.color(hcontrol) 1 1 1 21 1
    drawline -rn %pop.win $gui.color(hcontrol) 1 1 1 1 $calc($window(%pop.win).h - 2)
  }
  else drawrect -rn %pop.win $gui.color(fcontrol) 1 1 1 21 $calc($window(%pop.win).h - 2)

  while ($hget(popups,$+($1,.,%pop.compteur))) {
    var %pop.text = $gettok($v1,1,58)
    var %pop.cmd = $gettok($v1,2,58)
    var %pop.ico = $gettok($v1,3,58)

    if (%pop.ico) drawpic -sn %pop.win 4 $calc(%pop.y - 1) 16 16 %pop.ico

    if (%pop.text == -) {
      drawline -rn %pop.win $gui.color(shadow) 1 27 $calc(%pop.y - 1) $calc(%pop.width - 7) $calc(%pop.y - 1)
      drawline -rn %pop.win $gui.color(hilight) 1 27 %pop.y $calc(%pop.width - 7) %pop.y
      inc %pop.y 4
    }
    else if ($left(%pop.text,1) == +) {
      drawtext -rn %pop.win $gui.color(text) Verdana 11 28 %pop.y $mid(%pop.text,2)
      drawtext -rn %pop.win $gui.color(text) Webdings 12 $calc(%pop.width - 20) $calc(%pop.y - 2) 4
      inc %pop.y 18

      hadd popups %pop.submenus $hget(popups,%pop.submenus) %pop.cmd

    }
    else if ($gettok(%pop.text,1,32) == -b) {
      drawtext -rn %pop.win $gui.color(hilight) Verdana 11 29 $calc(%pop.y + 1) $gettok(%pop.text,2-,32)
      drawtext -rn %pop.win $gui.color(shadow) Verdana 11 28 %pop.y $gettok(%pop.text,2-,32)
      inc %pop.y 18
    }
    else {
      drawtext -rn %pop.win $gui.color(text) Verdana 11 28 %pop.y %pop.text
      inc %pop.y 18
    }

    inc %pop.compteur
  }

  drawdot %pop.win
}

menu @Popups.* {
  mouse {

    var %pop.name = $gettok($mouse.win,2-,46)

    var %pop.y = 0, %pop.num = 1

    while ($calc($mouse.y - 5) >= %pop.y) {
      if ($hget(popups,$+(%pop.name,.,%pop.num)) == -) inc %pop.y 4
      else inc %pop.y 18
      inc %pop.num
    }

    dec %pop.y 12
    dec %pop.num

    if (%pop.num == $hget(popups,$+(%pop.name,.sel))) return

    tokenize 58 $hget(popups,$+(%pop.name,.,%pop.num))
    var %pop.width = $window($mouse.win).w

    if ($1) && ($1 != -) {

      popups.drawContents %pop.name

      drawrect -rn $mouse.win $gui.color(scontrol) 1 26 $calc(%pop.y - 2) $calc(%pop.width - 30) 18
      drawrect -frn $mouse.win $gui.color(fcontrol) 1 27 $calc(%pop.y - 1) $calc(%pop.width - 32) 16

      if ($left($1,1) == +) {
        drawtext -rn $mouse.win $gui.color(textshadow) Verdana 11 30 $calc(%pop.y + 1) $mid($1,2)
        drawtext -rn $mouse.win $gui.color(text) Verdana 11 29 %pop.y $mid($1,2)

        drawtext -rn $mouse.win $gui.color(textshadow) Webdings 12 $calc(%pop.width - 19) $calc(%pop.y - 1) 4
        drawtext -rn $mouse.win $gui.color(text) Webdings 12 $calc(%pop.width - 20) $calc(%pop.y - 2) 4

        popups.draw $2 $calc($window($mouse.win).x + %pop.width) $calc($window($mouse.win).y + %pop.y - 6)
        $+(.timerPopups.,$2) -m 0 100 popups.leaveSubMenu $mouse.win $2 4 $calc(%pop.y - 2) $calc(%pop.width - 8) 18
      }
      else if ($gettok($1,1,32) == -b) {
        drawtext -rn $mouse.win $gui.color(shadow) Verdana 11 31 $calc(%pop.y + 2) $gettok($1,2-,32)
        drawtext -rn $mouse.win $gui.color(hilight) Verdana 11 30 $calc(%pop.y + 1) $gettok($1,2-,32)
      }
      else {
        drawtext -rn $mouse.win $gui.color(textshadow) Verdana 11 30 $calc(%pop.y + 1) $1
        drawtext -rn $mouse.win $gui.color(text) Verdana 11 29 %pop.y $1
      }

      drawdot $mouse.win

      hadd popups $+(%pop.name,.sel) %pop.num

    }

  }

  uclick {

    var %pop.name = $gettok($mouse.win,2-,46)

    var %pop.y = 0, %pop.num = 1

    while ($calc($mouse.y - 5) >= %pop.y) {
      if ($hget(popups,$+(%pop.name,.,%pop.num)) == -) inc %pop.y 4
      else inc %pop.y 18
      inc %pop.num
    }
    dec %pop.y 12
    dec %pop.num

    tokenize 58 $hget(popups,$+(%pop.name,.,%pop.num))

    if ($left($1,1) == +) window -a $lactive
    else if ($gettok($1,1,32) == -b) return
    else {
      if ($hget(popups,$+(%pop.name,.parent))) popups.close $+(@Popups.,$v1)
      popups.close $mouse.win | if ($2) .timer -m 1 0 $2
    }


  }
}

alias popups.leaveSubMenu {
  var %pop.x = $window($1).dx, %pop.y = $window($1).dy

  if ($inrect($mouse.dx,$mouse.dy,%pop.x,%pop.y,$window($1).dw,$window($1).dh)) { 

    if (!$inrect($mouse.dx,$mouse.dy,$calc($3 + %pop.x),$calc($4 + %pop.y),$5,$6)) {
      popups.close $+(@Popups.,$2) 1
    }

  }
}

alias popups.close {
  var %pop.name = $gettok($1,2-,46)
  if ($window($1)) .signal -n $+(popups.,%pop.name) CLOSE
  $+(.timer,$mid($1,2)) off
  window -c $1 

  var %pop.submenus = $hget(popups,$+(%pop.name,.submenus)), %pop.compteur = 1
  while ($gettok(%pop.submenus,%pop.compteur,32)) { hdel -w popups $+($v1,.*) | inc %pop.compteur }

  if (!$2) hdel -w popups $+($gettok($1,2-,46),.*) 
  else hdel popups $+($gettok($1,2-,46),.sel)
}

on *:close:@Popups.*:popups.close $target
